if(!dojo._hasResource["com.ibm.mm.builder.WidgetLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.WidgetLoader"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */	
dojo.provide("com.ibm.mm.builder.WidgetLoader");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");
dojo.require("com.ibm.mashups.builder.Personalize");

dojo.declare("com.ibm.mm.builder.WidgetLoader",null,{

	// summary: WidgetLoader is a utility class, it is used to load widgets from string format. 
	// The string format of widgets are load from a persisted file. 
	
	namespaces: {
		"thr":"http://purl.org/syndication/thread/1.0",
		"atom":"http://www.w3.org/2005/Atom",
		"xhtml":"http://www.w3.org/1999/xhtml",
		"xsi":"http://www.w3.org/2001/XMLSchema-instance",
		"portal":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model",
		"model":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements",
		"base":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base"
	},
	
	/**
	 * load widgets inside a container node.
	 * @param {DomNode} node: a container node
	 * @param {String} data: all the widget microformats string value
	 */
	loadWidgets: function(/*DomNode*/node,/*String*/data) {
		node.innerHTML = data;
 
		//OpenSocial Support		
		var ss1 = dojo.query("." + com.ibm.mm.builder.constant.iwIWidget, node); //spec
		ss1 = ss1.concat(dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, node)); //legacy

		var ss2 = dojo.query("." + com.ibm.mm.builder.constant.iwGGadget, node); //spec
		ss2 = ss2.concat(dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, node)); //legacy
		var spans = ss1.concat(ss2);


		//var spans = dojo.query("."+com.ibm.mm.builder.constant.mmIWidget, node);
		var len = spans.length;
		for(var i=0; i<len; i++) {
			var span = spans[i];
			if(span.className.indexOf(com.ibm.mm.builder.constant.skinClass)!=-1) {
				var widgetId = span.id;
				com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(span);
				var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
				if (skinDiv) {
					dojo.addClass(skinDiv, "dojoDndItem");
				}
				// reload the widget's size from navigation state.
				var widgetSize = com.ibm.mashups.builder.Personalize.getPersonalizeSize(widgetId);
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				if (widgetSize) {
					if (com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId).loaded) {
						com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
						var payload = {
							widgetId: widgetId,
							width: widgetSize.w,
							height: widgetSize.h
						};
						eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
					} else {
						var callBackftn = function(){
							com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
							var payload = {
								widgetId: widgetId,
								width: widgetSize.w,
								height: widgetSize.h
							};
							eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
						};  // JSLINT-IGNORE:
						eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, this, callBackftn);
					}
				}
			}
		}
	},

	/**
	 * This method is used to get all the visible widget and separate the widget fragments into different column
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 * @param {Number} num: the column number of this column layout
	 */
	getColumnWidgets: function(pagecontent,num) {
		var filteredContent = this.filterWidgets(pagecontent,"true");
		var columnWidgets =  {};
		var widgetsString = "";	
        for (var i = 1; i <= num; i++) {
            columnWidgets[i + ""] = "";
        }
		var tmp = document.createElement("div");
		tmp.innerHTML = filteredContent;	
		var nodes = dojo.query("."+com.ibm.mm.builder.constant.iwIWidget,tmp); //spec	
		nodes = nodes.concat(dojo.query("."+com.ibm.mm.builder.constant.mmIWidget,tmp)); //legacy
		var len = nodes.length;
        for (var x = 0; x < len; x++) {
            var achild = nodes[x];
            if (achild.tagName !== null && (achild.tagName == "DIV" || achild.tagName == "SPAN")) {
				if (achild.getAttribute("layoutdata")){
					var numStr = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData(achild.getAttribute("layoutdata"));
					columnWidgets[numStr+""] = columnWidgets[numStr+""] + com.ibm.mm.builder.utils.htmlUtil.getElementString(achild);					
				}
            }				
        }	
		return columnWidgets;
	},

	/**
	 * This method is used to get the free form layout widget fragments
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 */
	getFreeFormWidgets: function(pagecontent){
		return this.filterWidgets(pagecontent,"true");
	},

	/**
	 * This method is used to get the hidden widget corral widget fragments
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 */	
	getInnerNVA: function(pagecontent){
		return this.filterWidgets(pagecontent,"false");
	},
	
	/**
	 * This method is used to separate the widget into visible or invisible widget fragments
	 * @param {String} pcontent
	 * @param {boolean} visible
	 */
	filterWidgets:function(pcontent,visible){
		var tmp = document.createElement("div");
		tmp.innerHTML = pcontent;
		var widgets = dojo.query("."+com.ibm.mm.builder.constant.iwIWidget,tmp); //spec
		widgets = widgets.concat(dojo.query("."+com.ibm.mm.builder.constant.mmIWidget,tmp)); //legacy
		//OpenSocial support
		var gadgets = dojo.query("." + com.ibm.mm.builder.constant.iwGGadget, tmp); //spec
		gadgets = gadgets.concat(dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, tmp)); //legacy
		var nodes = widgets.concat(gadgets);

		var len = nodes.length;
		var defaultNvaSkin = null;
		
		if (len>0){
			defaultNvaSkin = com.ibm.mm.builder.utils.skinUtil.getNVANode().getID();
		}
        for (var x = 0; x < len; x++) {
            var achild = nodes[x];
            if (achild.tagName !== null && (achild.tagName == "DIV" || achild.tagName == "SPAN")) {
				if (visible != achild.getAttribute("visible")){
					tmp.removeChild(achild);
				}
				// fix bug 11905 - provide fallback support for nva skin.
				if (visible === "false") {
					var skin_tag_name = com.ibm.mm.builder.constant.widget_span_attr_skin;
					var nvaSkin = achild.getAttribute(skin_tag_name);
					if (nvaSkin) {
						if (nvaSkin !== defaultNvaSkin) {
							achild.setAttribute(skin_tag_name, defaultNvaSkin);
						}
					}
				}
            }				
        }	
		var flitered = tmp.innerHTML;
		delete tmp;  // JSLINT-IGNORE:
		return flitered; 
	},
	
	filter: function(str) {
		str = str.replace(/&lt;/g,"<");
		str = str.replace(/&gt;/g,">");
		return str;
	},
	
	getContentUrl: function(doc) {
		var links = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry/atom:link",doc,this.namespaces);
		for(var i=0; i<links.length; i++) {
			var link =this.loadXmlString(com.ibm.mm.builder.utils.htmlUtil.getElementString(links[i]));
			if(link.firstChild.getAttribute("portal:rel")=="fragment") {
				return link.firstChild.getAttribute("href");
			}		
		}
		return "#";
	},
	
	getContent: function(doc) {
		var contents = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry/atom:content",doc,this.namespaces);
		return com.ibm.mm.builder.utils.htmlUtil.getElementString(contents[0].firstChild);
	},
	
	getRealContent: function(url, root) {
		var content = "";
		var bindArgs = {
			url: url,
			sync: true,
			handle: function(type,data,evt) {
				var xmlDoc = this.loadXmlString(data);
				var contents = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(
					"atom:feed/atom:entry/atom:content",xmlDoc, root.namespaces);
				content = com.ibm.mm.builder.utils.htmlUtil.getElementString(contents[0].firstChild);
			}
		};
		dojo.xhrGet(bindArgs);
		return content;
	},	
	loadXmlString: function(sXml){
        var oXmlDoc;
        if (typeof ActiveXObject != "undefined") {
            oXmlDoc = new ActiveXObject("MSXML2.DOMDocument");
            oXmlDoc.async = 0;
            oXmlDoc.resolveExternals = 0;
            if (!oXmlDoc.loadXML(sXml)) {
                //Callers should catch this and can substitute their own error message
                throw new Error("Error loading xml string " + sXml);
            }
        }
        else {
            var parser = new DOMParser();
            try {
                oXmlDoc = parser.parseFromString(sXml, "text/xml");
            } 
            catch (exc) {
                //Callers should catch this and can substitute their own error message
                throw new Error("Error loading xml string " + sXml);
            }
        }
        return oDomDoc;
    }
});

com.ibm.mm.builder.widgetsLoaderObject = null;

com.ibm.mm.builder.initWidgetLoader = function(){
	if(!com.ibm.mm.builder.widgetsLoaderObject){
		com.ibm.mm.builder.widgetsLoaderObject = new com.ibm.mm.builder.WidgetLoader();
	}
	return com.ibm.mm.builder.widgetsLoaderObject;
};

}
