if(!dojo._hasResource["com.ibm.mm.builder.commonActions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.commonActions"] = true;
/**
 * Common Action class
 * Provides the global public functions
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.require("dojo.string");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions");
dojo.provide("com.ibm.mm.builder.commonActions");

com.ibm.mm.builder.commonActions.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.commonActions");

com.ibm.mm.builder.commonActions.isAnonymous = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var anonymousUser = cs.getValue("anonymousUser");
	return anonymousUser;
};

com.ibm.mm.builder.commonActions.isAnonymousMode = function(){
	var userModel = com.ibm.mashups.enabler.user.Factory.getUserModel();
	return userModel.getAnonymousMode() == com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS;
};

com.ibm.mm.builder.commonActions.isAuthenticated = function(){
	return !com.ibm.mm.builder.commonActions.isAnonymousMode();
};

com.ibm.mm.builder.commonActions.isSecurityOff = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var securityOff = cs.getValue("securityOff");
	return securityOff;
};

com.ibm.mm.builder.commonActions.isAnonymousCreate = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var value = cs.getValue("com.ibm.mashups.anonymous.mode.locked.on");
	var anonymous = com.ibm.mm.builder.commonActions.isAnonymous();
	var securityOff = com.ibm.mm.builder.commonActions.isSecurityOff();	
	if (securityOff) { return true; }

	return !anonymous ? true : value;
};

com.ibm.mm.builder.commonActions.hasHub = function(){
	return builderConfig.hasHub;
};

com.ibm.mm.builder.commonActions.changePageMode = function(mode, callbackFunc){
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.changePageMode", mode);
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode(mode);
	var navigationStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
	var pageModeAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageModeAccessor(navigationStateModel);
	pageModeAccessor.setPageMode(mode);
	var deferred = navigationStateModel.commit();
	if (callbackFunc) {
		deferred.setFinishedCallback(callbackFunc);
	}
	deferred.start(false);
};

com.ibm.mm.builder.commonActions.viewPageSource = function() {
	var dialogParam = {
		title: com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SOURCE_TITLE,
		type: "source",
		sharedWidget: true,
		nodeWidth:"900px",
		//nodeHeight:"500px",
		containerBackgroundColor: "white",
		hasRightBottomResizer:false
	};
	var payload = {
	    	widgetTypeId: "pageSource",
	        eventName:  "com.ibm.mashups.builder.loadPageSource",
	        eventPayload:  "",
	        dialogParam:  dialogParam
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.canViewMorePage = function(){
	return !!com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().findDefaultAcceptParent();
};

com.ibm.mm.builder.commonActions.viewMorePage = function(){
	var dialogParam = {
		title: com.ibm.mm.builder.coreWidgetsStrings.I_MORE_PAGE_TITLE,
		nodeWidth: "600px",
		containerBackgroundColor: "white",
		hasLeftBottomResizer: false,
		hasRightBottomResizer: false 
	};

	var payload = {
	    	widgetTypeId: "viewMorePage",
	        eventName:  "com.ibm.mashups.builder.viewMorePage",
	        eventPayload:  "",
	        dialogParam:  dialogParam,
	        requestRefresh: true
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.widgetCreation = function(){
	var dialogParam = {
		title : com.ibm.mm.builder.coreWidgetsStrings.I_WIDGET_BUILDER,
		nodeWidth: "350px",
		containerBackgroundColor: "white",
		hasLeftBottomResizer: false,
		hasRightBottomResizer: false
	};

	var payload = {
	    	widgetTypeId: "createNewWidget",
	        eventName:  "com.ibm.mashups.builder.createNewWidget",
	        eventPayload:  "",
	        dialogParam:  dialogParam,
	        requestRefresh: true
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.viewCatalog = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGUI);
};

com.ibm.mm.builder.commonActions.catalogNewWindow = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGUI_NEW_WINDOW, true);
};

com.ibm.mm.builder.commonActions.catalogFeedCreation = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATEFEEDUI);
};

com.ibm.mm.builder.commonActions.catalogFeedMashupCreation = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI);
};

com.ibm.mm.builder.commonActions.catalogWidgetCreation = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATENEWWIDGETUI);
};

com.ibm.mm.builder.commonActions.catalogWidgetCreationNewWindow = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATENEWWIDGETUI, true);
};

com.ibm.mm.builder.commonActions.savePage = function(){
	if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
		
		com.ibm.mashups.services.ServiceManager.getService("eventService")
			.broadcastEvent("com.ibm.mashups.builder.savePage");
		
		this.LOGGER.info(
			"savePage",
			dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.I_TOOLBOX_PAGE_SAVED_1,
				[com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle()])
		);
	}
};

com.ibm.mm.builder.commonActions.hwdDialogID = null;
com.ibm.mm.builder.commonActions.showHWC = function(){
	var hwdDialog = dijit.byId(com.ibm.mm.builder.commonActions.hwdDialogID);
	if(!hwdDialog) {
		var scroll = dojo._docScroll();
		var leftValue = scroll.x + 730;
		if (builderConfig.isBidi) {
			leftValue = dojo.isIE===6 ? 230 : 180;
		}
		var left = leftValue + "px";
		var top = (scroll.y + 100) + "px";
		com.ibm.mm.builder.commonActions.hwdDialogID = dojo.dnd.getUniqueId();
		var dialogParam = {
            id: com.ibm.mm.builder.commonActions.hwdDialogID,
            nodeWidth: "375px",
            nodeHeight: "360px",
            nodeStyle: "overflowY:auto",
            title: com.ibm.mm.builder.coreWidgetsStrings.I_NVA_TITLE,
            displayCloseButton: true,
            hasRightBottomResizer: false,
            modelDialog: false,
            titleBarHeight: 25,
            endBarHeight: 18,
            sharedWidget: true,
			initLeftPosition: left,
			initTopPosition: top,
			alwaysCenter: false,
			needUnderLay: false
        };
		var payload = {
		    	widgetTypeId: "hiddenWidgetCorral",
		        eventName:  null,
		        eventPayload:  null,
		        dialogParam:  dialogParam
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService")
			.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	}
	else {
		if (hwdDialog.open) {
			hwdDialog.hide();
		} else {
			hwdDialog.show();
		}
	}
};

com.ibm.mm.builder.commonActions.accountSettings = function() {
	var payload = {
		widgetTypeId: "editPage",
		eventName: "com.ibm.mashups.builder.editPage",
		eventPayload: null,
		requestRefresh: true,
		dialogParam: {
			id: "accountSettings",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_ACCOUNT,
			nodeWidth: "420px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.publishPage = function(pageId){
	if(!pageId) {
		com.ibm.mm.builder.commonActions.LOGGER.severe("com.ibm.mm.builder.commonActions.publishPage", "can not get the page id");
		return;
	}
	var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
	//if the page is just changed but not saved, show a dialog to let user to save and publish, or publish without save
	if (changed) {
		var dlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
			contentWarning: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_TEXT1,
			contentQuestion: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_TEXT2,
			btnSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_SAP,
			btnNotSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_PWOS,
			btnCancelText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_RETURN,
			charLimit: 22,
			frameWidth: (dojo.isIE || dojo.isSafari == 3.2) ? "690px" : "680px",
			callbackSave: function(){
				com.ibm.mm.builder.commonActions.loadPublish(pageId);
			},
			callbackNotSave: function(){
				com.ibm.mm.builder.commonActions.loadPublish(pageId);
			}
		});
		dlg.show();
	}else {
		com.ibm.mm.builder.commonActions.loadPublish(pageId);
	}
};

com.ibm.mm.builder.commonActions._canDoPageActions = function(pageId){
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var page = navigationModel.find(pageId).start();
	var type = page.getNavigationElementType();
	if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
		return true;
	} else if (type ==  com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
		return false;
	} else  {
		return false;	
	} 
};

com.ibm.mm.builder.commonActions.confirmEmbedPage = function(pageId){
	return com.ibm.mm.builder.commonActions._canDoPageActions(pageId);
};

com.ibm.mm.builder.commonActions.confirmPublishPage = function(pageId){
	return com.ibm.mm.builder.commonActions._canDoPageActions(pageId);
};

com.ibm.mm.builder.commonActions.canSharePage = function(pageId){
    if (!pageId) { return false; }
    var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    var pageNode = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
    if (!navigationModel.hasLayoutModel(pageNode)) { return false; }
	var pageAC = com.ibm.mm.builder.utils.acModelUtil.getPageAC(pageId);
	var ret = false;
	if (pageAC){
		ret = pageAC.confirmGetRoleModel();
	}
    return ret;
};

com.ibm.mm.builder.commonActions.sharePage = function(pageId){
	var pageName = com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId);
	if(!pageName || (pageName === null)){
		pageName = "";
	}
	var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
	
	var payload = {
    	widgetTypeId: "sharePage",
        eventName:  "com.ibm.mashups.builder.sharePage",
        eventPayload:  pageId,
		requestRefresh: true,
        dialogParam: {
			title: title,
			nodeWidth: "774px",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
};

com.ibm.mm.builder.commonActions.embedPage = function(pageId){
	var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
	if (changed) {
		var dlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
			contentWarning: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_TEXT1,
			contentQuestion: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_TEXT2,
			btnSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_SAP,
			btnNotSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_PWOS,
			btnCancelText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_RETURN,
			charLimit: 28,
			frameWidth: "800px",
			callbackSave: function(){
				com.ibm.mm.builder.commonActions.loadEmbedding(pageId);
			},
			callbackNotSave: function(){
				com.ibm.mm.builder.commonActions.loadEmbedding(pageId);
			}
		});
		dlg.show();
	}else {
		com.ibm.mm.builder.commonActions.loadEmbedding(pageId);			
	}
};

com.ibm.mm.builder.commonActions.canCreateSubPage = function(pageId) {
	if (!com.ibm.mm.builder.commonActions.isAnonymousCreate()){
		return false;
	}
	if (!pageId) {
		return false;
	}
	return com.ibm.pb.contextMenu.sharedActions.confirmCreatePage(pageId);
};

com.ibm.mm.builder.commonActions.canEditPage = function(pageId) {
	return com.ibm.mm.builder.utils.pageUtil.canEdit(com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId));	
};

com.ibm.mm.builder.commonActions.canReorderPage = function(pageId) {
	return com.ibm.pb.contextMenu.sharedActions.confirmMovePage(pageId);	
};

com.ibm.mm.builder.commonActions.editPage = function(pageId){
	
	var payload = {
    	widgetTypeId: "editPage",
        eventName:  "com.ibm.mashups.builder.editPage",
        eventPayload: pageId,
		requestRefresh: true,
        dialogParam: {
			id: pageId + "_pageProperty",
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_PAGE, [com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
			nodeWidth: "515px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
};

// To be implemented by portal
com.ibm.mm.builder.commonActions.getSpaceId = function() {
	return null;
};

com.ibm.mm.builder.commonActions.reorderPage = function(pageId) {
	var currentPageName = com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle();
	var eventPayload = {
		pageId: pageId,
		spaceId: com.ibm.mm.builder.commonActions.getSpaceId()
	};
	var payload = {
        widgetTypeId: "reorderPage",
        eventName: "com.ibm.mashups.builder.reorderPage",
        eventPayload: eventPayload,
		requestRefresh: true,
        dialogParam: {
			id: pageId + "_reorderPane",
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_REORDER_PAGE_DIALOG_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth: "420px",
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
    };
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.canDeletePage = function(pageId) {
	if (!pageId) {
		return false;
	}
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var navModel = navigationUtil.getNavigationModel();
	return navModel.confirmRemove(pageUtil.getPageNode(pageId));
};

com.ibm.mm.builder.commonActions.confirmRemovePage = function(pageId) {
	var _pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var pageNode = _pageUtil.getPageNode(pageId);
	var canRemove = navigationModel.confirmRemove(pageNode) && pageNode.getContent;
	if(canRemove) {
	    var contentNode = pageNode.getContent().start();
	    return !navigationModel.confirmRemove(contentNode);
	}
	return false;
};

com.ibm.mm.builder.commonActions.deletePage= function(pageId){
	
        if (!pageId) {
            this.LOGGER.severe("deletePage", com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
		var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId);
		var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
		var currentPageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		
        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var page = null;

		try {
			page = navModel.find(pageId).start();
		} catch (e) {
			return;		
		}

		var bundle = com.ibm.mm.builder.coreWidgetsStrings;
		var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
        var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
        var message = dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_PROMPT, [enablerUtil.getNodeTitle(page)]);
        this._deletePageDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete page",
			title: dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : dojo.hitch(this, function() {
				com.ibm.mm.builder.utils.pageUtil.deletePage();				
                var d = new dojo.Deferred();        
				d.callback();
                return d;
            }),
            okCallback : dojo.hitch(this, function() {
				if(com.ibm.mm.builder.utils.pageUtil.isRoot(parentPageId)) {
					parentPageId = com.ibm.mm.builder.utils.pageUtil.getFirstRootPageId();
				}
				//refresh navigation
				var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchPage", parentPageId);
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.spacemanager.deletePage", {currentPageId:currentPageId, parentPageId: parentPageId, pageId: pageId});
            })
        },this._deletePageDialog);
};

com.ibm.mm.builder.commonActions.newChildPage = function(){
	var dialog = new com.ibm.widgets.NewPageDialog({
		showMakePrivate:false,
		showFriendlyURL: false,
		blankImg: ibmConfig.themeBasePath + "css/images/blank.gif",
		onChange: function(value){
			com.ibm.mm.builder.navigationHelper.treeModel.newItem(value,com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode());
		}
	});
	dialog.focus();
};

com.ibm.mm.builder.commonActions.canCopyPageInSpace = function(pageId) {
	if (!pageId) {
		return false;
	}
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var spaceId = spaceUtil.getSpaceIdByPageId(pageId);
	
	return pageUtil.canEdit(navigationUtil.getNavigationRootNode(spaceId));
};

com.ibm.mm.builder.commonActions.loadEmbedding = function(pageId){ 
	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(pageId, "page");
};

com.ibm.mm.builder.commonActions.canPublishPage = function(pageId){
    if (!pageId) { return false; }
    var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    var pageNode = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
    if (!navigationModel.hasLayoutModel(pageNode)) { return false; }
    return navigationModel.confirmExport(pageNode);
};

com.ibm.mm.builder.commonActions.loadPublish = function(pageId){
    var currentPageName = com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId);
	var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_PUBLISH_PAGE_TITLE, [currentPageName]);
	
    var payload = {
        widgetTypeId: "publishWidget",
        eventName: "com.ibm.mashups.builder.publishPage",
        eventPayload: pageId,
		requestRefresh: true,
        dialogParam: {
			title: title,
            nodeWidth: "480px",
			needUnderLay: true,
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
    };
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};


//************* widget context menu call back functions

com.ibm.mm.builder.commonActions.showEditPane = function(widgetId){
	// temp fix for old widget spec
	var oldWidgetConfigId = "";
	var oldWidgetConfigParentNode = null;
	// end temp fix
	
	var widgetSpan = dojo.byId(widgetId);
	var configNodeId = "";
	
    var items = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.mmItem, widgetSpan);
    dojo.forEach(items, function(item){
    	var str = com.ibm.mm.builder.utils.iWidgetSpecUtil.getKeyFromHref(item);
        if (str == com.ibm.mm.builder.constant.configPannelNode) {
			configNodeId = "_" + widgetId + "_" + item.innerHTML.replace(/\n/g, "");
		}
    });
	
	if (configNodeId){
		// temp fix for old widget spec
		oldWidgetConfigId = configNodeId;
		oldWidgetConfigParentNode = dojo.byId(configNodeId).parentNode;
		// end temp fix
//		var editnode = dojo.byId(configNodeId);
//		editnode.style.display = "";
//		this.editorDiv.appendChild(editnode);
	}	
	var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
	var editPane = new com.ibm.mm.builder.widget.CustomDialog({
		id: widgetId+"_edit",
		title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_SYSTEM_CONF_TITLE,[_title]),
		type: "config",
		nodeWidth: dojo.byId(widgetId).getAttribute("sandbox") === "true" ? "400px" : null,
		needModeSwitch: true,
		belongId: widgetId,
		containerBackgroundColor: "white"
	});	
	
	var editActionHandle = dojo.subscribe(iwConstants.EVENTS.modeChanged, editPane, editPane.hide);
	
	editPane.closeCallback = function() {
		dojo.unsubscribe(editActionHandle);
		editPane.destroy();
	};
	
	if (!configNodeId) {
        com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(widgetId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: editPane.containerNode
        });
    }
	// temp fix for old widget spec
	if (oldWidgetConfigId != ""){
		var _oldWidgetConfigId = oldWidgetConfigId;
		var _oldWidgetConfigParentNode = oldWidgetConfigParentNode;
		editPane.oldWidgetSpecHitch = function(){
			if ((_oldWidgetConfigId != "") && (_oldWidgetConfigParentNode)) {
				dojo.byId(_oldWidgetConfigId).style.display = "none";
				_oldWidgetConfigParentNode.appendChild(dojo.byId(_oldWidgetConfigId));
			}
		};
	}
	// end temp fix
	editPane.show();
//	var editActionHandle = dojo.subscribe(iwConstants.EVENTS.modeChanged, this.editPane, this.editPane.hide);
};

com.ibm.mm.builder.commonActions.confirmRenameWidget = function(){
	var runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
	if (runtimeModel.getCurrentPage().getPageMode() == "edit"){
		return true;
	}
	return false;
};

com.ibm.mm.builder.commonActions.renameWidget = function(widgetId){
	var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(widgetId);
    var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(layoutControl);
	var title = "";
	if (widgetTitle){
		title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RENAME_WIDGET_PROMPT, [widgetTitle]);
	}
	var dialogParam = {
		title: title,
		nodeWidth: "400px",
		containerBackgroundColor: "white",
		hasRightBottomResizer: false
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", {
	    widgetTypeId: "renameWidget",
	    eventName:  "com.ibm.mashups.builder.renameAction",
	    eventPayload:  widgetId,
	    dialogParam:  dialogParam,
		requestRefresh: true
	});
};

com.ibm.mm.builder.commonActions.resizeWidget = function(widgetId){
	var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(widgetId);
	var widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(layoutControl,dojo.locale);
	var title = "";
	if (widgetTitle){
		title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RESIZE_WIDGET_PROMPT, [widgetTitle]);
	}
	var skinMinSize = "100px";

	var dialogParam = {
		title: title,
		nodeWidth: "395px",
 		containerBackgroundColor: "white",
		requestRefresh:true
 	};
	var resizeDialog = new com.ibm.mm.builder.widget.ResizeWidget({
		dlgPara: dialogParam
	});
	resizeDialog.minHeight = skinMinSize;
	resizeDialog.setTitle(title);
	resizeDialog.updateProperty(widgetId);
};

com.ibm.mm.builder.commonActions.confirmResizeWidget = function(widgetId){
	var isEdit = (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "edit");
	var w = com.ibm.pb.layout.LayoutParser.findById(widgetId);
	if (!w) return false;
	var p = w.parentNode;
	var isfreeform = false;
	while(p && p.id!="layoutContainers"){
		if (dojo.hasClass(p, "ibmFreeform")) {
			isfreeform = true;
			break;
		}else {
			p = p.parentNode
		}
	}
	return isfreeform && isEdit;
}; 

com.ibm.mm.builder.commonActions.moveWidget = function(widgetId){
	var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(widgetId);
	var widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(layoutControl,dojo.locale);
	var title = "";
	if (widgetTitle) {
		title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MOVE_WIDGET_PROMPT, [widgetTitle]);
	}
    var dialogParam = {
		title: title,
		nodeWidth: "395px",
 		containerBackgroundColor: "white"
    };
    var moveDialog = new com.ibm.mm.builder.widget.MoveWidget({
        dlgPara: dialogParam
    });
    moveDialog.updateProperty(widgetId);
};

com.ibm.mm.builder.commonActions.confirmMoveWidget = function(widgetId){
	var isEdit = (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "edit");
	var w = com.ibm.pb.layout.LayoutParser.findById(widgetId);
	if (!w) return false;
	var p = w.parentNode;
	var isfreeform = false;
	while(p && p.id!="layoutContainers"){
		if (dojo.hasClass(p, "ibmFreeform")) {
			isfreeform = true;
			break;
		}else {
			p = p.parentNode
		}
	}
	return isfreeform && isEdit;
}; 

com.ibm.mm.builder.commonActions.editWiring = function(widgetId) {
	com.ibm.mm.builder.skinHelper.launchWiring(widgetId);
};

com.ibm.mm.builder.commonActions.viewWiringGraph = function(widgetId) {
	var existingCanvas = dijit.byId(widgetId + "_wiringCanvas");
	if (existingCanvas) {
		existingCanvas.destroy();
	}

	dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");
	var wiringCanvas = new com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas({
		id: widgetId + "_wiringCanvas",
		selectedWidgetId: widgetId
	});
	wiringCanvas.showGraph();
};

//lable provider function
com.ibm.mm.builder.commonActions.displayOrHideLabel = function(widgetId) {
	var inNVA = com.ibm.mm.builder.commonActions.isWidgetHidden(widgetId);
	return inNva ? com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_DISPLAY : com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_HIDE;
};

com.ibm.mm.builder.commonActions.isWidgetHidden = function(widgetId) {
	
};

com.ibm.mm.builder.commonActions.displayOrHideWidget = function(widgetId) {
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent(
		com.ibm.mm.builder.commonActions.isWidgetHidden(widgetId) ? "com.ibm.mashups.builder.hideWidget" : "com.ibm.mashups.builder.displayWidget", 
		widgetId
	);
};

com.ibm.mm.builder.commonActions.removeWidget = function(widgetId){
	// this method is used only to remove the end user widget instance
	var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHandlerExt);
	if (resizeHandler) { resizeHandler.destroy(); }
	
	var resizeHeightHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHeightExt);
	if (resizeHeightHandler) { resizeHeightHandler.destroy(); }

	var quickWireTarget = com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
	if(quickWireTarget){
		quickWireTarget.destroy();
		delete com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
	}

	var editBar = dijit.byId(widgetId + com.ibm.mm.builder.constant.editbarDragHandler);
	if (editBar) { editBar.destroy(); }

	var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	if(dojo.attr(widgetId, "visible") === "false"){
		var wireIcon = dojo.byId(widgetId + "_wireIcon");
    	var editIcon = dojo.byId(widgetId + "_editIcon");
		if (editIcon) {
			editIcon.onclick = editIcon.onkeypress = null;
		}
		if (wireIcon) {
			wireIcon.onclick = wireIcon.onkeypress = null;
		}
	}
	if (dojo.isIE || dojo.isSafari) {
		var widgetBody = dojo.query(".widgetBody", widgetSkin)[0];
		if (widgetBody) { widgetBody.onselectstart = null; }
	}
	
	com.ibm.mm.builder.utils.layoutUtil.refreshLayoutData(widgetId);
	
	com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, widgetId);

	setTimeout(function(){
		dojo.destroy(widgetSkin);
	    com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeRemoved();
	}, 50);
};

//*******************  callback function for space action menu **************************
				
com.ibm.mm.builder.commonActions.publishSpace = function(spaceId){
	if(!spaceId) {return;}
	var cb = function(){
		var payload = {
	        widgetTypeId: "publishWidget",
	        eventName: "com.ibm.mashups.builder.publishSpace",
	        eventPayload: spaceId,
			requestRefresh: true,
	        dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.PUBLISH_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
	            nodeWidth: "450px",
	            containerBackgroundColor: "white",
	            hasRightBottomResizer: false
	        }
	    };
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
};

com.ibm.mm.builder.commonActions.canEditSpaceProperties = function(spaceId){
	var s = com.ibm.mm.builder.utils.spaceUtil;
	return s.canEdit(s.getSpaceNode(spaceId));
};

com.ibm.mm.builder.commonActions.canPublishAsTemplate = function(){
	return com.ibm.mm.builder.commonActions.hasHub() && com.ibm.mm.builder.commonActions.isAnonymousCreate();
};

com.ibm.mm.builder.commonActions.canCreateNewFeed = function(){
	return com.ibm.mm.builder.commonActions.hasHub() && com.ibm.mm.builder.commonActions.isAnonymousCreate();
};

com.ibm.mm.builder.commonActions.canCreateDataMashup = function(){
	return com.ibm.mm.builder.commonActions.canCreateNewFeed();
};

com.ibm.mm.builder.commonActions.editSpaceProperties = function(spaceId) {	
    var payload = {
        widgetTypeId: "editSpace",
        eventName: "com.ibm.mashups.builder.spaceEditor",
        eventPayload: spaceId,
		requestRefresh: true,
        dialogParam: {
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.EDIT_SPACE_PROPERTIES, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth: "975px",
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
	};
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.canShowRemoveSpaceFromFavorite = function() {
	return com.ibm.mm.builder.commonActions.isAuthenticated();
};

com.ibm.mm.builder.commonActions.isSpaceInFavorite = function(spaceId) {		
	if (spaceId) {
		space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
		if (space) { return space.isFavorite(); }
	}
	return false;
};

com.ibm.mm.builder.commonActions.addSpaceToFavorite = function(spaceId){
	if (spaceId) {
		com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.addSpaceToFavorite(spaceId);
	}
};

com.ibm.mm.builder.commonActions.isSpaceNotInFavorite = function(spaceId) {
	if (spaceId) { return !com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId); }
};

com.ibm.mm.builder.commonActions.removeSpaceFromFavorite = function(spaceId){
    if (spaceId) {
		com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.removeSpaceFromFavorite(spaceId);
	}
};

com.ibm.mm.builder.commonActions.canExportSpace = function(spaceId) {
    var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmExport(spaceUtil.getSpaceNode(spaceId));
};

com.ibm.mm.builder.commonActions.exportSpace = function(spaceId){
	if (spaceId) {
		var cb = function(){
			com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.exportSpace(spaceId);
		};
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
	}
};
	
com.ibm.mm.builder.commonActions.canCopySpace = function(spaceId) {
    var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmCopy(spaceUtil.getSpaceNode(spaceId));
};

com.ibm.mm.builder.commonActions.copySpace = function(spaceId) {
	var cb = function(){
		var payload = {
			widgetTypeId: "copySpace",
			eventName: "com.ibm.mashups.builder.copySpace",
			eventPayload: spaceId,
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "350px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
};

com.ibm.mm.builder.commonActions.canShareSpace = function(spaceId) {
	if (!spaceId) { return false; }
	return com.ibm.mm.builder.utils.acModelUtil.getSpaceAC(spaceId).confirmGetRoleModel();
};

com.ibm.mm.builder.commonActions.shareSpace = function(spaceId) {
	var cb = function(){
		var currentSpaceName = com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SHARESPACE_DIALOG_TITLE, [currentSpaceName]);
		
		var payload = {
	        widgetTypeId: "sharePage",
	        eventName:  "com.ibm.mashups.builder.shareSpace",
	        eventPayload:  spaceId,
			requestRefresh: true,
	        dialogParam: {
				title: title,
				nodeWidth: "774px",
				hasRightBottomResizer: false
			}
	    };
	    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
};

com.ibm.mm.builder.commonActions.canDeleteSpace = function(spaceId) {
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmRemove(spaceUtil.getSpaceNode(spaceId));
};

com.ibm.mm.builder.commonActions.deleteSpace = function(spaceId) {
	if (spaceId) {
		var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (!space) {
            return;
        }
		var bundle = com.ibm.mm.builder.coreWidgetsStrings;
		var message = dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_PROMPT, [enablerUtil.getNodeTitle(space)]);
		
        var _deleteSpaceDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete space",
			title : dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_TITLE, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : function() {
                if(spaceUtil.isHomeSpace(spaceId)){
					spaceUtil.setHomeSpaceId();
				}
                
                if (com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId)) {
					com.ibm.mm.builder.commonActions.removeSpaceFromFavorite(spaceId);
				}
				
                spaceModel.remove(space);
				spaceModel.commit().start();
				if(spaceUtil.isWelcomeSpace(spaceId)){
					spaceModel = spaceUtil.getSpaceModel(true);
				}
                var d = new dojo.Deferred();
                var deferred = function(){};
                d.callback({});
                return d;
            },
            okCallback : function() {
				dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space["delete"],[spaceId]);
                dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.DELETE_SPACE, {spaceId: spaceId}]);				
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				var sid = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId();
				if(!spaceModel.find(sid).start()){
					sid = null;
				}
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace", sid);
            }
        }, _deleteSpaceDialog);
	}
};

com.ibm.mm.builder.commonActions.canCreatePageInSpace = function(spaceId){
	var u = com.ibm.mm.builder.utils;
	return u.pageUtil.canEdit(u.navigationUtil.getNavigationRootNode(spaceId)) &&
		com.ibm.mm.builder.commonActions.isAnonymousCreate();
};

com.ibm.mm.builder.commonActions.createSpaceCopy = function(spaceId){
	var payload = {
		widgetTypeId: "copySpace",
		eventName: "com.ibm.mashups.builder.copySpace",
		eventPayload: spaceId,
		requestRefresh: true,
		dialogParam: {
			title: com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION,
			nodeWidth: "350px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.isEmbeddingAvailable = function(){
	// This is a sample method for Portal to customize.
	return true;
};

com.ibm.mm.builder.commonActions.isWidgetBuilderAvailable = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	return cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.WIDGET_BUILDER_ENABLED);
};

com.ibm.mm.builder.commonActions.isPersonalSpaceAvailable = function(){
	// This is a sample method for Portal to customize.
	return true;	
};

com.ibm.mm.builder.commonActions.isSpaceImportExportEnabled = function(){
	return ibmConfig.enable_import_export_space;	
};

com.ibm.mm.builder.commonActions.isHomeSpace = function(spaceId){
	return com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE") && com.ibm.mm.builder.utils.spaceUtil.isHomeSpace(spaceId);
};

com.ibm.mm.builder.commonActions.makeHomeSpace = function(spaceId){
	var originalHomeSpaceId = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId();
	com.ibm.mm.builder.utils.spaceUtil.setHomeSpaceId(spaceId);
	dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.MAKE_HOME, {originalHomeSpaceId: originalHomeSpaceId, spaceId: spaceId}]);
};
	
com.ibm.mm.builder.commonActions.isNotHomeSpace = function(spaceId){
	return com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE") && !com.ibm.mm.builder.commonActions.isHomeSpace(spaceId);
};
	
com.ibm.mm.builder.commonActions.unmakeHomeSpace =  function(spaceId){
	com.ibm.mm.builder.utils.spaceUtil.setHomeSpaceId();
	dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.UNMAKE_HOME, {spaceId: spaceId}]);
};

com.ibm.mm.builder.commonActions.canEmbedPage = function(){
	if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID()) { return true; }
	return false;
};

com.ibm.mm.builder.commonActions.canSetHomeSpace = function(spaceId){
	return com.ibm.mm.builder.commonActions.isNotHomeSpace(spaceId) && !com.ibm.mm.builder.commonActions.isAnonymousMode();
};

com.ibm.mm.builder.commonActions.canSetFavorite = function(spaceId){
	return com.ibm.mm.builder.commonActions.isSpaceNotInFavorite(spaceId) && !com.ibm.mm.builder.commonActions.isAnonymousMode();
};


}
