if(!dojo._hasResource["com.ibm.mm.builder.iwidget.TabSpaceSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.TabSpaceSelector"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.TabSpaceSelector");

(function(){
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var themeUtil = utils.themeUtil;
var spaceUtil = utils.spaceUtil;
var acModelUtil = utils.acModelUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;

//todo remove hard-code length
var borderWidth = 23;
var itemLen = 150;
var minManageWidth = itemLen;

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelector",
	[dijit._Widget, dijit._Templated, dijit._Container],{

	templateString: '<ul class="lotusInlinelist lotusLinks spaceSelector" wairole="tablist"></ul>',
	
	refresh: function(spaceId){

		this.uninitialize();
		var fontStyle = {};
		if(dojo.isIE) {
			fontStyle.fontSize = "12px";
		}
		dojo.attr(this.domNode,"role","menubar");
		//get width between Logo and commonActionsMenu for displaying space Items
		var logoPos = dojo.query("div.lotusLogo").position()[0];
		var beforeLen = logoPos.x + logoPos.w + borderWidth;
		var actionsMenuNode = dojo.query("#CommonActionsList")[0];
		var action = dojo.query(".lotusInlinelist", actionsMenuNode).position()[0];
		var actionsPosX = action.x - borderWidth;
		var maxLeftLen = actionsPosX - beforeLen;
		if(maxLeftLen < 0) {
			actionsPosX = action.x + action.w + borderWidth;
			beforeLen = logoPos.x - borderWidth;
			maxLeftLen = beforeLen - actionsPosX;
		}

// ---> PMR 20508
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var spaceSelectorItems = mycontextmenu.getContextMenu("ContextMenu.spaceSelector.v3", spaceId, "space", null);
		var showPersonalSpace, showSpaceManager, showListOfSpaces = false;
		var showPersonalSpaceFunction, showSpaceManagerFunction, showListOfSpacesFunction;
		for (var i = 0; i < spaceSelectorItems.length; ++i) {
			if (spaceSelectorItems[i].id == "personalspace") {
				showPersonalSpace = true;
				showPersonalSpaceFunction = spaceSelectorItems[i].actionCallBackFunctionName;
			}
			else if (spaceSelectorItems[i].id == "spacemanager") {
				showSpaceManager = true;
				showSpaceManagerFunction = spaceSelectorItems[i].actionCallBackFunctionName;
			}
			else if (spaceSelectorItems[i].id == "listofspaces") {
				showListOfSpaces = true;
				showListOfSpacesFunction = spaceSelectorItems[i].actionCallBackFunctionName;
			}
		}
		
		//create home space
		var homeSpaceId = spaceUtil.getHomeSpaceId();
		if(homeSpaceId){
			var node = spaceUtil.getSpaceNode(homeSpaceId);
			if (node) {
	            this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorHomeItem({
	                model: node,
					leftLen : maxLeftLen
	            }));
				maxLeftLen = maxLeftLen - htmlUtil.getStrWidth(spaceUtil.getSpaceTitle(homeSpaceId), this.domNode, fontStyle) - borderWidth;
			} else {
				spaceUtil.setHomeSpaceId();
					
				if (com.ibm.mm.builder.commonActions.isSpaceInFavorite(homeSpaceId)) {
					com.ibm.mm.builder.commonActions.removeSpaceFromFavorite(homeSpaceId);
				};
			}
		}
		
		//create personal space
		if (showPersonalSpace) {
			if (showPersonalSpaceFunction)
				eval(showPersonalSpaceFunction).call(this, maxLeftLen, minManageWidth, fontStyle);
			else
				eval("com.ibm.mm.builder.iwidget.TabSpaceSelector.createPersonalSpace").call(this, maxLeftLen, minManageWidth, fontStyle);
		}
		//create space manager
		if (showSpaceManager) {
			if (showSpaceManagerFunction)
				eval(showSpaceManagerFunction).call(this, maxLeftLen, minManageWidth, fontStyle);
			else
				eval("com.ibm.mm.builder.iwidget.TabSpaceSelector.createSpaceManager").call(this, maxLeftLen, minManageWidth, fontStyle);
		}
		// create other spaces
		if (showListOfSpaces) {
			if (showListOfSpacesFunction)
				eval(showListOfSpacesFunction).call(this, maxLeftLen, minManageWidth, fontStyle);
			else
				eval("com.ibm.mm.builder.iwidget.TabSpaceSelector.createFavoriteSpacesLinks").call(this, maxLeftLen, minManageWidth, fontStyle);
		}
// <--- PMR 20508
	},
	
	uninitialize: function(){
		dojo.forEach(this.getChildren(), function(item){	
			this.removeChild(item);
			dijit.byId(item.id).destroy();
			item.destroyRecursive();		
			delete item;			
		},this);
		//dojo.forEach(this.getChildren(), "item.destroy()");
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorItem", [dijit._Widget, dijit._Templated], {

	templateString: '<li><a href="javascript:;" dojoAttachPoint="containerNode" role="menuitem" tabindex=0 dojoAttachEvent="onkeypress:_onKeypress, onclick:_onClick"></a></li>',
	
	postCreate: function(){
		dojo.attr(this.containerNode, "title", spaceUtil.getSpaceTitle(this.model.getID()));
		var limitedTitle = htmlUtil.getStrWithLimit(spaceUtil.getSpaceTitle(this.model.getID()), this.containerNode, Math.min(itemLen, this.leftLen));
		this.containerNode.innerHTML = limitedTitle;
		this.setUnderline();
	},
	
	isCurrentSpace: function() {
		var result = false;
		var currentSpace = spaceUtil.getCurrentSpaceId();
        var globalPageOpenedSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
        if (globalPageOpenedSpaceId) {
         	if (this.model && this.model.getID() === globalPageOpenedSpaceId) {
          		result = true;
         	}
       } else {
            if (spaceUtil.getCurrentSpaceId() && (this.model && (spaceUtil.getCurrentSpaceId() === this.model.getID())) ) {
               result = true;
            }
       }


		return result;
	},
	
	setUnderline: function() {
		// Underline the current space or a space hosting global pages (which appears as the current space)
		if (this.isCurrentSpace()){
			this.containerNode.style.textDecoration = "underline";
			this.addSelectedText(this.containerNode);
		}
	},	

	addSelectedText: function(node) {
		dojo.require("dojo.i18n");
		dojo.requireLocalization("com.ibm.bundles", "Theme");
		var spanNodes = dojo.query("span.ibmPortalHiddenText[current_space=true],span.wpthemeAccess[current_space=true]",node);
		var currentlySelected = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["currently_selected"];
		if(!spanNodes.length){
			dojo.create("span",{innerHTML:currentlySelected ,className:"",className:"ibmPortalHiddenText ibmHiddenText wpthemeAccess", current_space:true}, node);
		}
	},

	_onKeypress: function(e){
		if (e.keyCode === dojo.keys.ENTER) {
			this._onClick(e);
		}
	},
	
	_onClick: function(e) {
		if(this.isCurrentSpace()) return;
		var spaceId = this.model? this.model.getID():null;
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(dojo.hitch(this, function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace", spaceId);
			// add space to the recent visited space list
			this._addToVisited(spaceUtil.getCurrentSpaceId());
		}));
	},
	
	_addToVisited: function(spaceId) {
		// null if it is "My Mashup Apps"
		if(spaceId) {
			var spaceItem = {"id":spaceId, "title":spaceUtil.getSpaceTitle(spaceId, dojo.locale)};
			var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
			dojo.publish(constants.Topic.Space.addToRecentSpaces, [spaceItem]);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerMoreItem", com.ibm.mm.builder.iwidget.TabSpaceSelectorItem, {
	templateString: 
		'<li><a href="javascript:;" dojoAttachPoint="containerNode" tabindex=0 role="menuitem" dojoAttachEvent="onkeypress:_onKeypress"></a></li>',

	postCreate: function(){
		dojo.attr(this.containerNode, "title", cws.I_SPACE_MORE_SPACES);
		this.containerNode.innerHTML = cws.I_SPACE_MORE_SPACES;
		this.spaceSelectorMenu = new com.ibm.mm.builder.iwidget.TabSpaceSelectorMenu({ 
			gotNodeId: this.GotNodeId,
			__spaceNodes: this._spaceNodes,
			targetNodeIds: [this.domNode]
		});
	},
	_onKeypress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				this.spaceSelectorMenu._openMyself(evt);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorPersonalItem", com.ibm.mm.builder.iwidget.TabSpaceSelectorItem, {
	
	postCreate: function(){
		dojo.attr(this.containerNode, "title", cws.I_SPACE_PERSONAL_SPACE);
		this.containerNode.innerHTML = cws.I_SPACE_PERSONAL_SPACE;
		this.setUnderline();
	},
	
	setUnderline: function() {
		if (!spaceUtil.getCurrentSpaceId()){
			this.containerNode.style.textDecoration = "underline";
			this.addSelectedText(this.containerNode);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorHomeItem", com.ibm.mm.builder.iwidget.TabSpaceSelectorItem, {
	templateString:
		'<li>'
			+'<a href="javascript:;" dojoAttachPoint="containerNode" tabIndex="0" dojoAttachEvent="onkeypress:_onKeypress, onclick:_onClick"></a>'
		+'</li>',
	
	postCreate: function(){
		this.inherited(arguments);
		var selectedSpan = dojo.create("span",{innerHTML:cws.I_SPACE_IS_HOME_SPACE ,className:"",className:"ibmPortalHiddenText ibmHiddenText wpthemeAccess"});
		this.containerNode.appendChild(selectedSpan);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerBaseItem",[dijit._Widget, dijit._Templated], {
	_onClick: function() {
		
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()) {
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING2,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
		        hideNotSave: true,
		        callbackSave: dojo.hitch(this, function() {
					this._showSpaceManager();
				}),
				callbackCancel: null
		    });
		    saveConfirmDlg.show();
		} else {
			this._showSpaceManager();
		}
       
	},
	
	_showSpaceManager : function () {
		 var payload = {
            widgetTypeId: "spaceManager",
            eventName: "com.ibm.mashups.builder.showSpaceManager",
            eventPayload: "",
            dialogParam: {
                title: cws.I_SPACE_MANAGE_SPACES,
                nodeWidth: "910px",
                nodeHeight: "750px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }
        };
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);	
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerTabItem", [com.ibm.mm.builder.iwidget.TabSpaceSelectorItem, com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerBaseItem], {

	postCreate: function(){
		dojo.attr(this.containerNode, "title", cws.I_SPACE_MANAGE_SPACES);
		this.containerNode.innerHTML = cws.I_SPACE_MANAGE_SPACES;
		dojo.attr(this.containerNode, "role", "button");
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerMenuItem", [dijit.MenuItem, com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerBaseItem], {
	label: cws.I_SPACE_MANAGE_SPACES,
	postCreate: function(){
		dijit.MenuItem.prototype.postCreate.call(this);
		htmlUtil.markTruncation(this.containerNode, this.itemLen);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TabSpaceSelectorMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	leftClickToOpen: true,
	postCreate: function(){
		dojo.addClass(this.domNode, "lotusCommonActionMenu spaceSelectorMenu");
		if(!this.isLeftToRight()){ this.offset_x = -9;}
		this.inherited(arguments);
		dojo.attr(this.domNode,"width",minManageWidth+"px");
	},
	
	prepareData: function(){
		spaceNodes = this.__spaceNodes;
		var self = this;
		self.addChild(new dijit.MenuSeparator());
		while (spaceNodes.hasNext()) {
			(function(){
				var node = spaceNodes.next();
				if(node.getID() === spaceUtil.getHomeSpaceId()) {
					return ;
				}
				if (spaceUtil.isVisiable(node)) {
					self.addChild(new  dijit.MenuItem ({
						label: com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(node),
						postCreate: function(){
							dijit.MenuItem.prototype.postCreate.call(this);
							htmlUtil.markTruncation(this.containerNode,this.itemLen);
							dojo.attr(this.containerNode, "role", "menuitem");
							dojo.attr(this.focusNode, "space_id", node.getID());
							dojo.attr(this.containerNode, "title", node.getTitle(dojo.locale));
						},
						_onClick: function(){
							dijit.popup.close(this.getParent());
							var callbackFun = dojo.hitch(this, function(){
								eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",node.getID());
							});
							com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
						}
					}));
				}
			})();
		}
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
	},
	
	switchToPersonalSpace: function(){
		eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace");
	}
});

com.ibm.mm.builder.iwidget.TabSpaceSelector.createPersonalSpace = function(maxLeftLen, minManageWidth, fontStyle) {
	this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorPersonalItem());
	maxLeftLen = maxLeftLen - htmlUtil.getStrWidth(cws.I_SPACE_PERSONAL_SPACE, this.domNode, fontStyle) - borderWidth;
};
	
com.ibm.mm.builder.iwidget.TabSpaceSelector.createSpaceManager = function(maxLeftLen, minManageWidth, fontStyle) {
	this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerTabItem());
	maxLeftLen = maxLeftLen - htmlUtil.getStrWidth(cws.I_SPACE_MANAGE_SPACES, this.domNode, fontStyle) - borderWidth;
};

com.ibm.mm.builder.iwidget.TabSpaceSelector.createViewSpacesLinks = function(maxLeftLen, minManageWidth, fontStyle) {
    var spaceNodes = spaceUtil.getSpaceModel().iterator();
    eval("com.ibm.mm.builder.iwidget.TabSpaceSelector.createListOfSpaces").call(this, spaceNodes, maxLeftLen, minManageWidth, fontStyle);
};

com.ibm.mm.builder.iwidget.TabSpaceSelector.createFavoriteSpacesLinks = function(maxLeftLen, minManageWidth, fontStyle){
    var spaceNodes = spaceUtil.getSpaceModel().findFavorites();
    eval("com.ibm.mm.builder.iwidget.TabSpaceSelector.createListOfSpaces").call(this, spaceNodes, maxLeftLen, minManageWidth, fontStyle);
};	

com.ibm.mm.builder.iwidget.TabSpaceSelector.createListOfSpaces = function(spaceNodes, maxLeftLen, minManageWidth, fontStyle){
    //create other spaces
    var count = 0;
    var node;
    // var spaceNodes = spaceUtil.getSpaceModel().findFavorites();
    var currentSId = spaceUtil.getCurrentSpaceId();
    var homeSpaceId = spaceUtil.getHomeSpaceId();
    
    while (maxLeftLen > minManageWidth && spaceNodes.hasNext()) {
        var cursor = spaceNodes.getCursorPosition();
        node = spaceNodes.next();
        if (node.getID() === homeSpaceId) {
            continue;
        }
        
        // if you are the masnager of this space you can still see the page and space		
        if ((!node.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER)) && (node.isHidden())) {
            if (node.getID() === currentSId) {
                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
            }
            continue;
        };
        
        //If there are more than two spaces left, and the left width for title is not enough for next space title and "More spaces", break loop and display spaces in menu
        var titleWidth = htmlUtil.getStrWidth(spaceUtil.getSpaceTitle(node.getID()), this.domNode, fontStyle) + borderWidth;
        titleWidth = titleWidth > itemLen ? itemLen : titleWidth;
        if ((titleWidth + borderWidth + htmlUtil.getStrWidth(cws.I_SPACE_MORE_SPACES, this.domNode, fontStyle) + borderWidth) > maxLeftLen && spaceNodes.hasNext()) {
            spaceNodes.setCursorPosition(cursor);
            break;
        }
        this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorItem({
            model: node,
            leftLen: maxLeftLen
        }));
        count++;
        maxLeftLen = maxLeftLen - titleWidth;
    }
    //create space menu or space manager 
    if (spaceNodes.hasNext() && count < spaceNodes.sizeValue) {//if there are some spaces left
        //calculate left spaces title tab width, then return to cursor position
        var cursor = spaceNodes.getCursorPosition();
        var totalWidth = 0;
        while (spaceNodes.hasNext()) {
            node = spaceNodes.next();
            if (node.getID() === homeSpaceId) {
                continue;
            };
            
            if (node.isHidden()) {
                if (node.getID() === currentSId) {
                    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
                }
                continue;
            };
            
            totalWidth = borderWidth + totalWidth + htmlUtil.getStrWidth(spaceUtil.getSpaceTitle(node.getID()), this.domNode, fontStyle);
        }
        spaceNodes.setCursorPosition(cursor);
        if (totalWidth <= maxLeftLen) {//if left width is enough for all spaces tab
            while (spaceNodes.hasNext()) {
                node = spaceNodes.next();
                if (node.getID() === homeSpaceId) {
                    continue;
                }
                
                if (node.isHidden()) {
                    if (node.getID() === currentSId) {
                        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
                    }
                    continue;
                };
                
                this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorItem({
                    model: node,
                    leftLen: itemLen
                }));
            }
        }
        else {
            this.addChild(new com.ibm.mm.builder.iwidget.TabSpaceSelectorManagerMoreItem({
                _spaceNodes: spaceNodes,
                GotNodeId: currentSId,
                leftLen: maxLeftLen
            }));
        }
    }
};

})();

}
