if(!dojo._hasResource["com.ibm.mm.builder.model.ContextMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.ContextMenu"] = true;
dojo.provide("com.ibm.mm.builder.model.ContextMenu");

dojo.require("com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader");
dojo.require("com.ibm.mashups.builder.model.ContextMenu");
dojo.require("com.ibm.mashups.builder.model.ContextMenuLoader");
dojo.require("com.ibm.mm.builder.DeferredImpl");
dojo.require("com.ibm.mm.builder.DelegatedDeferredImpl");
dojo.require("com.ibm.mm.builder.DeferredListImpl");
              
/**
 * Implementation of builder runtime context menu model.
 */
dojo.declare( "com.ibm.mm.builder.model.ContextMenuImpl", [com.ibm.mashups.builder.model.ContextMenu], {
	
	_baseTopic: "Builder/ContextMenuImpl",
	
	configServiceLoader: new com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader(),
	
	constructor: function() {
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
		this._menus = {};
		this._contrIdCounter = 0;
		this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.refreshContextMenu", this, "_fireChange");
	},
	
	getContextMenu:function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
		var mname = "getContextMenu", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		dojo.deprecated("com.ibm.mashups.builder.model.ContextMenu.getContextMenu", "The method com.ibm.mashups.builder.model.ContextMenu.getContextMenu is deprecated, please use com.ibm.mashups.builder.model.ContextMenu.getContextMenuDeferred instead!")
		var results = this.getContextMenuDeferred.apply(this, arguments).start();
		lgr.exiting(mname, [results]);
		return results;
	},
	
	getContextMenuDeferred:function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
		var mname = "getContextMenuDeferred", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var menuDef = this._getMenuDef(contextMenuId),
			cnbt = menuDef.contributions.slice(),		// get a copy so we can mess with it
			baseLoader = menuDef.base || this.configServiceLoader,
			loaderArgs = [contextMenuId, targetResourceId, targetResourceType, someObject];
		// if nothing is registered to this contextMenuId, default to the ConfigService one
		
		var baseDfd = baseLoader.getItems.apply(baseLoader, loaderArgs);
		
		var dfdContribsArray = dojo.map(cnbt, function(contribObj){
			// contribObj is of the form {loader: contributionLoader, ordinal: ordinal, id: id, items: undefined|null|items}
			return contribObj.loader.getItems.apply(contribObj.loader, loaderArgs);
		}, this);
		
		var mergingDfdList = new com.ibm.mm.builder.DeferredListImpl(this);
		mergingDfdList.add(baseDfd).add.apply(mergingDfdList, dfdContribsArray);
		
		var retDfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params) {
			var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(),
				res, me = this;
			mergingDfdList.setFinishedCallback(function(result, status, dfdPms){
					res = me._mergingCallback.apply(me, arguments);
					if(callBack) {
						callBack(res, status, callBackParams);
					}
				},{
					contextMenuId: contextMenuId,
					contributions: cnbt
				}).start(sync);
			return res;
		});
				
		lgr.exiting(mname, [retDfd]);
		return retDfd;
	},
	_mergingCallback: function(resultsList, status, params) {
		var mname = "_mergingCallback", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// each item in resultsList is in the form [dfdResult, dfdStatus, dfdParams]
		var loadedList = [], len = resultsList.length, ret;
		if(len > 0) {
			// pull the base items off the front
			var baseItems = resultsList.shift();
			len--;
			if(baseItems[1] == 200) {
				loadedList.push(baseItems[0]);
			}
			else {
				lgr.severe(mname, com.ibm.mm.builder.coreWidgetsMessages.E_CONTEXT_MENU_FAIL_1, [[params.contextMenuId, baseItems[0], baseItems[1]]]);
			}
		}
		// now iterate over contributions
		for(var i=0; i<len; i++) {
			if(resultsList[i][1] == 200) {
				loadedList.push(resultsList[i][0]);
			}
			else {
				params.contributions.splice(i, 1);
				lgr.severe(mname, com.ibm.mm.builder.coreWidgetsMessages.E_CONTEXT_MENU_FAIL_2, [[ params.contextMenuId, resultsList[i][0], resultsList[i][1] ]]);
			}
		}
		ret = this._mergeItems(loadedList, params);
		lgr.exiting(mname, [ret]);
		return ret;
	},
  	_mergeItems: function(resultLists, params) {
		// first item is the base menu
		// remaining items are contributions, and are sorted by ordinal already
		var items = [], i, j, k, len, item, contrItems,
			lclCtx = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
		if(resultLists.length > 0) {
			items.push.apply(items, resultLists[0]);
			len = resultLists.length;
			for(i=1; i<len; i++) {
				// push placemarkers in list for each contribution
				items.push({
					__isContribution__: true,	// special flag to mark as contribution
					contribution: params.contributions[i-1],		// actual contribution object
					ordinal: params.contributions[i-1].ordinal,		// actual ordinal of contribution as it was added to the menu
					items: resultLists[i]	// actual array of items from the contribution
				});
			}
			items.sort(this._sortByOrdinal);
			for(j=0; j<items.length; j++) {
				item = items[j];
				if(item.__isContribution__ === true) {
					contrItems = item.items.sort(this._sortByOrdinal);
					for(k=0; k<contrItems.length; k++) {
						if(contrItems[k].localized) {
							if(contrItems[k].title == null) {
								contrItems[k].title = lclCtx.getTitle(contrItems[k].localized);
							}
							if(contrItems[k].description == null) {
								contrItems[k].description = lclCtx.getDescription(contrItems[k].localized);
							}
						}
						contrItems[k].contributionId = item.contribution.id;
						contrItems[k].ordinal = j+k; // normalize ordinals to maintain grouping of contribution items
					}
					items.splice.apply(items, [j, 1].concat(contrItems)); // replace contribution placemarker with its items
					j += contrItems.length - 1; // increment j to account for new index and length
				}
				else {
					item.ordinal = j;	// normalize ordinals
				}
			}
		}
		return items;
	},
	_getMenuDef: function(contextMenuId) {
		if(!this._menus[contextMenuId]) {
			this._menus[contextMenuId] = {
				base: null,
				changeTimer: null,
				contributions: []	// of the form {loader: contributionLoader, ordinal: ordinal, id: id, delegator: null, connection: null}
			};
			/*
			 * Additional properties used elsewhere, but not defined here
			 * 		delegator: null,  - Singleton DelegatorDeferredImpl that can delegate callbacks to DelegatedDeferredImpls for the base menu items
			 * 		items: null		  - JSON[] of the actual finalized list of pre-transformed items, saves resource loading time
			 * 		connection: null  - Connection handle used by the system to monitor the onChange event of the base loader 
			 */
		}
		return this._menus[contextMenuId];
	},
	_genContrId: function(contextMenuId) {
		return contextMenuId + "_Contribution" + this._contrIdCounter++;
	},
	/**
	 * Connects a system listener to a loader's onChange event to handle it appropriately for that particular
	 * loader.
	 */
	_connectListener: function(contextMenuId, contextMenuLoader, cacheContext) {
		cacheContext.connection = dojo.connect(contextMenuLoader, "onChange", this, 
			function(){
				delete cacheContext.delegator;	// clear any potential cache of the loader
				this._fireChange(contextMenuId);
			}
		);
		return cacheContext.connection;
	},
	
	registerContextMenu: function(/*String*/ contextMenuId, /*com.ibm.mashups.builder.model.ContextMenuLoader*/ contextMenuLoader) {
		var mname = "registerContextMenu", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var def = this._getMenuDef(contextMenuId);
		def.base = contextMenuLoader;
		if(contextMenuLoader) {
			this._connectListener(contextMenuId, contextMenuLoader, def);
		}
		this._fireChange(contextMenuId);
		lgr.exiting(mname, [true]);
		return true;
	},
	
	addContribution: function(/*String*/ contextMenuId, /*com.ibm.mashups.builder.model.ContextMenuLoader*/ contributionLoader, /*Number*/ ordinal) {
		var mname = "addContribution", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var cnbt = this._getMenuDef(contextMenuId).contributions;
		var id = null;
		if(contributionLoader) {
			id = this._genContrId(contextMenuId);
			var contribObj = {loader: contributionLoader, ordinal: ordinal, id: id};
			cnbt.push(contribObj);
			cnbt.sort(this._sortByOrdinal);	// sort on insert
			// listen to the contribution's onChange event
			this._connectListener(contextMenuId, contributionLoader, contribObj); 
			this._fireChange(contextMenuId);
		}
		lgr.exiting(mname, [id]);
		return id;		
	},
	
	removeContribution: function(/*String*/ contextMenuId, /*String*/ id) {
		var mname = "removeContribution", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var cnbt = this._getMenuDef(contextMenuId).contributions,
			ret = null;
		if(id) {
			for(var i=0; i<cnbt.length; i++) {
				if(cnbt[i].id === id) {
					ret = cnbt[i].loader;
					if(cnbt[i].connection) {
						dojo.disconnect(cnbt[i].connection);
					}
					cnbt.splice(i, 1);
					break;
				}
			}
			if(ret) {
				this._fireChange(contextMenuId);
			}
		}
		lgr.exiting(mname, [ret]);
		return ret;
	},
	getContributions: function(/*String*/ contextMenuId) {
		var mname = "getContributions", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// contributions are sorted on insert
		var cnbt = this._getMenuDef(contextMenuId).contributions,
			ret = dojo.map(cnbt, function(contrib){
				return contrib.loader;
			}, this);
		lgr.exiting(mname, [ret]);
		return ret;
	},
	_sortByOrdinal: function(a, b) {
		return (a.ordinal != null ? a.ordinal : Number.MAX_VALUE) - (b.ordinal != null ? b.ordinal : Number.MAX_VALUE); // JSLINT-IGNORE: null|undefined ordinals go to the end
	},
	registerListener: function(/*String*/contextMenuId, /*Object*/scope, /*Function*/func) {
		var mname = "registerListener", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(arguments.length < 3) {
			func = scope;
			scope = dojo.global;
		}
		var ret = dojo.subscribe(this._baseTopic + "/" + contextMenuId, scope, func);
		lgr.exiting(mname, [ret]);
		return ret;
	},
	unregisterListener: function(/*Object*/ handle) {
		var mname = "unregisterListener", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var ret = dojo.unsubscribe(handle);
		lgr.exiting(mname, [ret]);
	},
	_fireChange: function(/*String*/ contextMenuId) {
		var mname = "_fireChange", lgr = this.LOGGER, me = this;
		lgr.trace(mname, "Queuing event to indicate context menu ${0} has been updated", [contextMenuId]);
		var menuDef = this._getMenuDef(contextMenuId);
		if(!menuDef.changeTimer) {
			menuDef.changeTimer = setTimeout(function(){
				lgr.trace(mname, "Firing event to indicate context menu ${0} has been updated", [contextMenuId]);
				clearTimeout(menuDef.changeTimer);
				delete menuDef.changeTimer;
				dojo.publish(me._baseTopic + "/" + contextMenuId, [contextMenuId]);
			}, 1);
		}
	}
});

}
