if(!dojo._hasResource["com.ibm.widgets.TreeModeled"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TreeModeled"] = true;
dojo.provide( "com.ibm.widgets.TreeModeled" );

dojo.require( "com.ibm.dnd.ModeledSource" );
 
/*
 * This module provides a simple API for creating a widget that is built from a data set through
 * some API.  Examples include but are not limited to the tree model API used by dijit.Tree and
 * the dojo.data API.  This module can be mixed in to other widgets that use data to build their
 * representations.
 */

dojo.declare( "com.ibm.widgets._DataBacked",
			null,
			{
				// _loaded: Boolean flag indicates whether or not this data backed widget has loaded
				//		its data yet
				_loaded: false,
				
				// _loading: Boolean flag indicates whether or not this data backed widget is currently
				//		loading its data
				_loading: false,
				
				load: function() {
					// summary: Loads the data used to build the implementing widget.  Subclasses should
					//		ensure that the _onLoad and _onLoading functions are called so that listeners
					//		to the onLoad and onLoading functions can receive proper notifications.
				},
				
				reload: function(force) {
					// summary: Reload a widget's data set in order to (optionally) rebuild
					//		the widget's representation.  Not all subclasses may support this.
					// force: Boolean indicating if reloading should be forced, potentially
					// 		cancelling any current reloading operation.  May be used, for example,
					//		in cases where something about the widget has changed since the
					//		last reload operation started.
				},
				_onLoad: function() {
					// implementations should call this internal function not the public one
					this._loaded = true;
					this._loading = false;
					this.onLoad();
				},
				_onLoading: function() {
					// implementations should call this internal function not the public one
					this._loading = true;
					this.onLoading();
				},
				
				onLoad: function() {
					// summary: Extension point called when data loading is finished regardless
					// 		of success or error.
				},
				onLoading: function() {
					// summary: Extension point called when data loading begins.
					
				}
			}
);


dojo.declare( "com.ibm.widgets.TreeModeled",
			com.ibm.widgets._DataBacked,
			{
				// summary:
				//		Mixin used for widgets that are built using a data model to represent
				//		data in some visual way.  Listens to model notifications of change events
				//		in order to update the representation of the model data in the widget.
				//		To use this mixin, call initializeModelWidget() in postCreate()
				//		and startupModelWidget() in startup().  They must also mixin the 
				// 		dijit._Container mixin or subclass an widget that already mixes it in.
				
				// model: Object which is an implementation	of the com.ibm.data.DataTreeModel
				// 		APIs.
				model: null,
				
				// item: Object the root item of this widget whose children will 
				//		populate the tabs in this widget.  Must be provided to root
				//		this widget at some point in the model.
				item: null,
				
				// items: Map of the widgets representing the children items of item retrieved 
				// 		from the model.  Keys are item ids and values are the widgets representing
				//		the items.
				items: null,
				
				// levels: Number of levels to recurse down the model when creating widget
				//		representations of the model.  Default is Number.MAX_VALUE, indicating 
				// 		no maximum depth, which will continue to create representations of 
				// 		descendants all the	way down the tree model.  Implementations should
				//		handle this accordingly when creating new children.
				levels: Number.MAX_VALUE,
				
				// level: Number the level of the current modeled widget in a heirarchy of modeled
				//		widgets.
				level: 0,
				
				// dndEnabled: Boolean indicates whether or not this widget should allow dnd operations
				dndEnabled: false,
				
				// dndClass: String class used to create a DND source object for this modeled widget
				dndClass: "com.ibm.dnd.ModeledSource",
				
				// dndAccept: Array of dnd types that this widget accepts
				dndAccept: null,
				
				// dndType: Array indicating the dndType(s) of items represented in this
				//		modeled widget.
				dndType: null,
				
				// dndCreator: Function dnd creator function
				dndCreator: null,
				
				// dndSingular: Boolean to determine if multiple items can be dragged
				//		simultaneously or not
				dndSingular: true,
				
				// dndDelay: Number of pixels to use as a delay before triggering a dnd operation
				dndDelay: 0,
				
				// dndHorizontal: Boolean indicating if this model widget should use horizontal dnd
				//		operations.  Default is false.
				dndHorizontal: false,
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "",
				
				// showLoadingOnBootstrap: Boolean indicating whether or not the loading indicator should be displayed
				//		during bootstrap of the widget, or at the first time it loads.  If false, then the loading
				//		indicator will only display after the first time the widget loads.
				showLoadingOnBootstrap: true,
				
				// showInlineEditor: Boolean indicating whether or not to show an inline editor widget 
				// 		somewhere in this modeled widget.  Implementations are free to handle this
				// 		however they please.  One example use case is to provide a means of creating 
				// 		new data in a data backed widget through an inline editor.  Inline editor
				//		onchange events are propagated to the onInlineEditorChange function with the
				//		parentItem and the new value passed as arguments.
				showInlineEditor: false,
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.  Must implement onChange, onCancel, and onEdit
				// 		events for the inline editor.  The com.ibm.widgets.InlineEditorWrapper mixin
				//		provides prebuilt logic for these handlers and can be mixed into other widgets
				//		that will contain the editor.
				inlineEditorWidget: "",
				
				// inlineEditorWidgetParams: Object set of parameters used when instantiating the 
				//		inline editor widget, like {required: true} or {constraints: {}}
				inlineEditorWidgetParams: {},
				
				// inlineEditorTitle: String title to display on hover over the inline editor
				//		while in edit mode
				inlineEditorTitle: "",
				
				// inlineEditorLabel: String default label to display in inline editor
				// 		when not in edit mode 
				inlineEditorLabel: "",
				
				// inlineEditorLabel: String default value to display in inline editor when going into
				// 		edit mode
				inlineEditorDefaultValue: "",
				
				// embeddedEditorWidget: Widget class used to instantiate the embedded inline editor
				//		used inside this modeled widget
				embeddedEditorWidget: "dijit.form.TextBox",
				
				// embeddedEditorParams: Object set of parameters used when instantiating the embedded
				//		inline editor widget, like {required: true} or {constraints: {}}
				embeddedEditorParams: {},
				
				embeddedEditorPopup: "com.ibm.widgets.InlineEditorPopup",
				embeddedEditorPopupParams: {},
				
				//bootstrapped: set to true after the widget is setup on initial page load
				bootstrapped: false,
						
				constructor: function() {
					this.inlineEditorWidgetParams = {};
					this.embeddedEditorParams = {};
					this.embeddedEditorPopupParams = {};
					this.items = {};
				},
				
				initializeModelWidget: function() {
					this.connect(this.model, "onTreeChange", "onModelTreeChange");
					this.connect(this.model, "onChange", "onModelChange");
					this.connect(this.model, "onChildrenChange", "onModelChildrenChange");
					
					if(!this.preloaded) {
						var loaderCls = dojo.getObject(this.loadingIndicatorWidget);
						if(loaderCls) {
							this.loadingIndicator = new loaderCls();
						}
					}
					
					if(this.showInlineEditor) {
						this.connect(this, "onLoad", "setupInlineEditor");
					}
					
					if (!dojo.isArray(this.dndAccept)) {
						this.dndAccept = [this.dndAccept];
					}
					this._dndParams = {
						model: this.model,
						item: this.item,
						skipForm: true,
						accept: this.dndAccept || [],
						singular: this.dndSingular,
						creator: this.dndCreator,
						delay: this.dndDelay,
						horizontal: this.dndHorizontal,
						dropParent: this.containerNode
					};
					
					if(this.dndEnabled && !this.preloaded) {
						this.setupDnd();	// not set up when preloaded, called after preload processing
					}
					
					this._draggingNodes = [];
				},
				
				startupModelWidget: function() {
					if (!this.preloaded && this.showLoadingOnBootstrap) {
						this.showLoading();
					}
				},
				
				setupInlineEditor: function() {
					if(!this.inlineEditor) {
						var editorCls = dojo.getObject(this.inlineEditorWidget);
						if(editorCls) {
							this.inlineEditor = new editorCls(dojo.delegate({
								label: this.inlineEditorLabel,
								title: this.inlineEditorTitle,
								defaultValue: this.inlineEditorDefaultValue,
								embeddedEditorWidget: this.embeddedEditorWidget,
								embeddedEditorParams: this.embeddedEditorParams,
								popupWidget: this.embeddedEditorPopup,
								popupParams: this.embeddedEditorPopupParams
							}, this.inlineEditorWidgetParams));
							
							this.connect(this.inlineEditor, "onChange", "_onInlineEditorChange");
							this.connect(this.inlineEditor, "onCancel", "onInlineEditorCancel");
							this.connect(this.inlineEditor, "onEdit", "onInlineEdit");
							this.addChild(this.inlineEditor);
						}
					}
				},
				
				setupDnd: function() {
					// summary: Called during postCreate to setup dnd operations for this widget.
					//		Subclasses may override for customized behavior.
					if(!this.dndSource) {
						this.dndEnabled = true;
						var cls = dojo.getObject(this.dndClass);
						this.dndSource = new cls(this.domNode, this._dndParams);
						this._dndConnects = [];
						this._dndConnects.push(this.connect(this.dndSource, "onDraggingOver", "onDraggingOver"));
						this._dndConnects.push(this.connect(this.dndSource, "onDraggingOut", "onDraggingOut"));
						this._dndConnects.push(this.connect(this.dndSource, "onDndStart", "onDndStart"));
						this._dndConnects.push(this.connect(this.dndSource, "onDndCancel", "onDndCancel"));
					}
					dojo.forEach(this.getChildren(), function(child){
						child.attr("dndStatus", true);
					}, this);
				},
				disableDnd: function() {
					this._disableLocalDnd();
					dojo.forEach(this.getChildren(), function(child){
						child.attr("dndStatus", false);
					}, this);
				},
				_disableLocalDnd: function() {
					if(this.dndSource) {
						this.dndEnabled = false;
						dojo.forEach(this._dndConnects, this.disconnect, this);
						this._dndConnects = [];
						this.dndSource.destroy();
						this.dndSource = null;
					}
				},
				destroy: function() {
					this._disableLocalDnd();
					this.inherited(arguments);
				},
				getInheritableParameters: function(item) {
					// summary: Returns an object map of parameters to use when constructing the
					//		widget representation of the next level of the model.  Subclasses
					//		can extend this and provide additional properties or override ones
					//		set here.  Much of this is boilerplate, so it's often easiest to
					//		call this.inherited(arguments) and then modify the result before
					//		returning.
					// item: Current item to use as the root of the next level in the model.
					return {
						item: item,
						model: this.model, 
						level: this.level + 1,
						levels: this.levels,
						showInlineEditor: this.showInlineEditor,
						inlineEditorLabel: this.inlineEditorLabel,
						inlineEditorTitle: this.inlineEditorTitle,
						inlineEditorDefaultValue: this.inlineEditorDefaultValue,
						embeddedEditorWidget: this.embeddedEditorWidget,
						embeddedEditorParams: dojo.mixin({}, this.embeddedEditorParams),
						embeddedEditorPopup: this.embeddedEditorPopup,
						embeddedEditorPopupParams: dojo.mixin({}, this.embeddedEditorPopupParams),
						dndCreator: this.dndCreator,
						dndEnabled: this.dndEnabled,
						dndAccept: this.dndAccept,
						dndSingular: this.dndSingular,
						dndDelay: this.dndDelay,
						dndType: this.dndType,
						onModelItemClick: this.onModelItemClick,
						setupInlineEditor: this.setupInlineEditor,
						seedPreloadedData: this.seedPreloadedData
					};
				},
				createItemRep: function(item) {
					// summary: Subclasses should implement this function to create a widget representation of
					//		a data item in the model which is a child of the item backing this widget.  Each
					//		representation created here should mixin dijit._Contained as they will be children
					//		of this widget.  They also must support the dndHandle attribute getter/setter to set 
					// 		and get a boolean value indicating whether or not a	dnd handle should be used on the item.
					// item: Object item in the model backing this widget
				},
				handlePreloaded: function() {
					// summary: Plugin point for overrides that handle instantiation of this widget where data
					//		has been provided in the contents of the of the widget itself.
					this.domNode.removeAttribute("item");
					dojo.forEach(this.getChildren(), function(wij){
						this.items[this.model.getIdentity(wij.item)] = wij;
						this._flagChildForDnd(wij);
						this._flagChildHasChildren(wij);
						wij.domNode.removeAttribute("item");
					}, this);
				},
				seedPreloadedData: function() {
					// summary: Called when a widget is instantiated with preloaded data.  Override this to
					//		parse the data and do any processing such as seeding the model or store with the
					//		data found in the widget source point.
				},
				showLoading: function() {
					if (this.loadingIndicator && !this._loaderVisible) {
						this.addChild(this.loadingIndicator);
						this._loaderVisible = true;
					}
				},
				clearLoading: function() {
					if (this.loadingIndicator && this._loaderVisible) {
						this.removeChild(this.loadingIndicator);
						this._loaderVisible = false;
					}
				},
				load: function(reloadTimeStamp) {
					// summary: Loads the children of this widget's item property from the model, and 
					// 		creates widgets	to represent each child item.  Can be overriden by subclasses 
					// 		to provide customized behavior.
					// returns: Boolean indicating whether or not this widget had any children to load.
					//		In either case, the onLoad and onLoading events are still fired.
					if (this._loaded || this._loading || !this.item) {
						return false; // already loaded, in process, or n/a
					}
					if(this.preloaded) {
						this.seedPreloadedData();
						this.handlePreloaded();
						if(this.showInlineEditor){
							this.setupInlineEditor();
						}
						if(this.dndEnabled) {
							this.setupDnd();	// not set up when preloaded
						}
						return false;
					}
					if(!this.model.mayHaveChildren(this.item)) {
						this.clearLoading();
						this._onLoading();
						this._onLoad();
						return false;
					}
					this._onLoading();
					this.model.getChildren(this.item, 
						dojo.hitch(this, function(items) {
							if(reloadTimeStamp && reloadTimeStamp < this._reloadTimeStamp) {
								return false;
							}
							this.clearLoading();
							if(this._loaded) {
								return false;
							}
							this.loadHandler(items);

							this._onLoad();
						}),
						dojo.hitch(this, function(error) {
							this.clearLoading();
							this._onLoad();
							this.onError(error);
						})
					);
					return true;
				},
				reload: function(force) {
					// summary: Reloads this widget's children by destroying the existing children
					//		that are backed by model items and then calling load again.
					// force: Boolean indicating if reloading should be forced, potentially
					// 		cancelling any current reloading operation.  May be used, for example,
					//		in cases where something about the widget has changed since the
					//		last reload operation started.
					if (this._loading && force != true) {
						return false;
					}
					this._loaded = this._loading = false;
					var items = this.items;
					for(var id in items) {
						this.removeChild(items[id]);
						items[id].destroyRecursive();
						delete items[id];
					}
					if (this.dndSource) {
						this.dndSource.sync();
					}
					this.showLoading();
					this.preloaded = false;
					if (this.model.resolver) {
						this.model.resolver.getValue(this.item, "children").reload();
					}
					this._reloadTimeStamp = new Date().getTime();
					return this.load(this._reloadTimeStamp);
				},
				loadHandler: function(items) {
					if(!this.showInlineEditor && this.inlineEditor){
							this.inlineEditor.destroy();
							this.inlineEditor = null;
					}else if(this.showInlineEditor && !this.inlineEditor){
							this.setupInlineEditor();
					}
					
					var insIndex = 0;
					if (this.inlineEditor) {								
						insIndex = this.getIndexOfChild(this.inlineEditor);
						if(insIndex < 0){ insIndex = null };
					}
					
					dojo.forEach(items, function(item){
						var childWidget = this._setupNewChild(item);
						this.items[this.model.getIdentity(item)] = childWidget;
						
						var li = null;
						if(!this.bootstrapped){
							li = dojo.query("> #"+this.model.getIdentity(childWidget.item), this.containerNode)[0];
						}									
						if(li){
							this.containerNode.replaceChild(childWidget.domNode,li);
							if (insIndex !== null) {
								this.addChild(childWidget, insIndex++);
							}else{
								this.addChild(childWidget);
							}
						}else{
							if (insIndex !== null) {
								this.addChild(childWidget, insIndex++);
							}
							else {
								this.addChild(childWidget);
							}
						}								
					}, this);
					this.bootstrapped = true;
					
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				_flagChildForDnd: function(childWidget) {
					//if(this.dndEnabled) {
						dojo.addClass(childWidget.domNode, "dojoDndItem");
						childWidget.domNode.setAttribute("dndType", this.dndType);
						childWidget.domNode.setAttribute("dndData", this.model.getLabel(childWidget.item));
						childWidget.attr("dndHandle", this._dndParams.withHandles);
					//}
				},
				_flagChildHasChildren: function(childWidget) {
					if(!this.model.mayHaveChildren(childWidget.item) || this.levels === 0 || this.level >= this.levels) {
						childWidget.attr("hasChildren", false);
					} else {
						childWidget.attr("hasChildren", true);
					}
				},
				_setupNewChild: function(item) {
					var childWidget = this.createItemRep(item);
					childWidget.item = item;
					this._flagChildForDnd(childWidget);
					this._flagChildHasChildren(childWidget);
					return childWidget;
				},
				onError: function(error) {
					// summary: Called when there is an error loading this widget.
					// error: Error data indicating what failed during the process of retrieving the children
					//		of this widget's item from the model.
					console.error(error);
				},
				onItemCreate: function(childWidget, item) {
					// summary: Can be fired for child items when they are created perhaps after the widget creates 
					// 		some representation of the item before it was created on the server.
				},
				onModelRemoveChild: function(/*Item*/ childItem) {
					var childWidgets = this.getChildren();
					for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
						if(wij.item == childItem) {
							delete this.items[this.model.getIdentity(childItem)];
							this.removeChild(wij);
							wij.destroyRecursive();
							for(var x in wij) {
								try {
									delete wij[x];
								}
								catch(e){
									wij[x] = null;
								}
							}
							if (this.dndSource) {
								this.dndSource.sync();
							}
							return;
						}
					}
				},
				onModelInsertChild: function(/*Item*/ childItem, /*Item*/ nextSiblingItem) {
					var childWidget = this._setupNewChild(childItem);
					var childWidgets = this.getChildren();
					var insIdx = null;
					if(nextSiblingItem) {
						for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
							if(wij.item == nextSiblingItem) {
								insIdx = i;
								break;
							}
						}
					}
					else {
						insIdx = this.getIndexOfChild(this.inlineEditor)
					}
					this.animateInChild(childWidget, insIdx);
					if(!this.model.isCreated(childItem)) {
						if(this._editorChangedWithFocus) {
							setTimeout(function(){
								dijit.focus(childWidget.focusNode ? childWidget.focusNode : childWidget.domNode);
							},0);
						}
						this._editorChangedWithFocus = false;
						childWidget.attr("disabled", true);
						this.model.addOnCreate(childItem, dojo.hitch(this, function(){
							this.items[this.model.getIdentity(childItem)] = childWidget;
							childWidget.attr("disabled", false);
							this.onItemCreate(childWidget, childItem);
						}));
					}
					else {
						this.items[this.model.getIdentity(childItem)] = childWidget;
					}
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				onModelReorderChild: function(/*Item*/childItem, /*Item*/nextSiblingItem) {
					var childWidgets = this.getChildren();
					var childWidget = null;
					for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
						if(wij.item == childItem) {
							childWidget = wij;
							this.removeChild(childWidget);
							// remove the item from the childWidgets node-list too, since we process
							// using the childWidgets below
							childWidgets.splice(i, 1);
							break;
						}
					}
					
					var insIdx = null;
					if(nextSiblingItem) {
						for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
							if(wij.item == nextSiblingItem) {
								insIdx = i;
								break;
							}
						}
					}
					else {
						insIdx = this.getIndexOfChild(this.inlineEditor);
					}
					this.animateInChild(childWidget, insIdx);
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
					// summary: Listens to changes in the tree model where a particular childItem is added, removed, or moved
					//		under a parent item in the tree.  Here are the semantics:
					//		1) If oldParentItem is non-null, the childItem used to be a child of the oldParentItem (and still
					//			may, depending upon the other conditions.  If it is null, then the childItem is being inserted
					//			into the tree under the newParentItem as a new created tree node.
					//		2) If newParentItem is non-null, the childItem is now a child of the newParentItem.  If newParentItem
					//			is null, then the item is being deleted from the tree altogether from under the oldParentItem.
					//			If newParentItem is equal to oldParentItem, then the childItem is being reordered among the list
					//			of children of its parent.
					//		3) If nextSiblingItem is non-null, then the item is being moved or inserted into the tree and the 
					//			nextSiblingItem is the next sibling of the childItem under its parent.
					// childItem: Item being operated on in the model.
					// oldParentItem: Item previous parent of the childItem
					// newParentItem: Item new parent of the childItem
					// nextSiblingItem: Item next sibling of the childItem
					var f = null;
					if(this.item == oldParentItem) {
						f = "onModelRemoveChild";
					}
					if(this.item == newParentItem) {
						f = f ? "onModelReorderChild" : "onModelInsertChild";
					}
					if(f) {
						this[f](childItem, nextSiblingItem);
						return true;
					}
					return false;
				},
				onModelChange: function(/*dojo.data.Item*/ item) {
					if(this.items[this.model.getIdentity(item)]) {
						// TODO: process the change
					}
					return false;
				},
				onModelChildrenChange: function(parentItem, children) {
					if(this.item != parentItem) {
						var parentId = this.model.getIdentity(parentItem), child = this.items[parentId];
						if(child) {
							this.handleChildChildrenChange(child, children || []);
						}
						return false;
					}
					// only handle the no-children case... all other updates to children are 
					// handled by the other callbacks
					if(this.anchor) {
						this.anchor.attr("hasChildren", children && children.length > 0);
					}
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
				},
				onModelItemClick: function(widget, item) {
					// summary: Extension point for getting notifications when users click
					//		a widget representing an item in this model.  By default, this
					//		is propogated to all cascading modeled widgets created by the
					//		model so that all descendants fire the same function.
					//		Implementations should ensure that any onclick event on a child 
					// 		widget representing	modeled data calls results in a call to this 
					// 		function with the appropriate arguments. 
				},
				onDraggingOver: function() {
					if(this.inlineEditor && this.dndSource.getAllNodes().length === 0) {
						// empty container... style the inlineEditor
						this.dndSource._addItemClass(this.inlineEditor.domNode, "Before");
					}
				},
				onDraggingOut: function() {
					if(this.inlineEditor && this.dndSource.getAllNodes().length === 0) {
						// empty container... style the inlineEditor
						this.dndSource._removeItemClass(this.inlineEditor.domNode, "Before");
					}
				},
				onDndStart: function(source, nodes, copy) {
					if(this.dndSource == source) {
						dojo.forEach(nodes, function(node){
							this._animateOut(node);
						}, this);
						this._draggingNodes = nodes;
					}
				},
				onDndCancel: function() {
					if (this.inlineEditor) {
						this.dndSource._removeItemClass(this.inlineEditor.domNode, "Before");
					}
					dojo.forEach(this._draggingNodes, function(node){
						this._animateIn(node);
					}, this);
					this._draggingNodes = [];
				},
				_animateIn: function(node) {
					if (node._animation) {
						node._animation.stop(true);
					}
					dojo.style(node, "display", "");
					var anim = dojo.fadeIn({
						node: node,
						duration: 500
					});
					if(dojo.isIE) {
						var filter = node.style.filter;
						anim.onEnd = function() {
							node._animation = null;
							node.style.filter = filter;
						}
					}
					node._animation = anim;
					anim.play();
					return anim;
				},
				_animateOut: function(node) {
					if (node._animation) {
						node._animation.stop(true);
					}
					var anim = dojo.fadeOut({
						node: node,
						duration: 500,
						onEnd: function() {
							node._animation = null;
							dojo.style(node, "display", "none");
						}
					});
					node._animation = anim;
					anim.play();
					return anim;
				},
				animateInChild: function(/*Widget*/ widget, /*int?*/ insertIndex) {
					// summary: Adds a child to this modeled widget but allows animation
					//		effects to display the new child.
					// returns: Animation object which has already been started on return.
					//		Returns null if no animation was used.
					var filter = null;
					if(dojo.isIE) {
						filter = widget.domNode.style.filter;
					}
					dojo.style(widget.domNode, "opacity", "0");
					(insertIndex >= 0) ? this.addChild(widget, insertIndex) : this.addChild(widget);
					var anim = this._animateIn(widget.domNode);
					// hack for IE to get filter exactly back to original before animation
					if (dojo.isIE) {
						var conn = dojo.connect(anim, "onEnd", function(){
							widget.domNode.style.filter = filter;
							dojo.disconnect(conn);
						});
					}
					return anim;
				},
				animateOutChild: function(/*Widget*/ widget) {
					// summary: Hides a child from this modeled widget but allows animation
					//		effects when hiding the child.  At the end of the animation,
					//		this removes the child.
					// returns: Animation object which has already been started on return.
					//		Returns null if no animation was used.
					var anim = this._animateOut(widget.domNode);
					dojo.connect(anim, "onEnd", this, function(){
						this.removeChild(widget);
					});
					return anim;
				},
				moveChild: function(/*Widget*/ widget, /*int?*/ newIndex) {
					this.removeChild(widget);
					this.animateInChild(widget, newIndex);
				},
				_onInlineEditorChange: function(value, focus) {
					this._editorChangedWithFocus = focus;
					this.onInlineEditorChange(value, this.item);
				},
				onInlineEditorChange: function(value, parentItem) {
					// summary: Override or connect to this function to get notifications of changes to
					//		this menu's inline editor (if one exists).  The default implementation calls 
					// 		the model's newItem function passing in an object of the form {title: newValue}
					//		as the first argument and the item of this widget as the parent in the second
					//		argument.
					// value: Object map of key-value pairs from the inline editor's composite value.
					// parentItem: Item which is root of the widget whose editor fired its onChange event.
					this.model.newItem(value, parentItem);
				},
				onInlineEditorCancel: function() {
					// summary: Override or connect to this function to get notified when the user cancels
					//		an edit operation in the inline editor.
				},
				onInlineEdit: function() {
					// summary: Override or connect to this function to get notified when the user starts
					//		an edit operation in the inline editor usually by clicking or entering the inline
					//		editor.
				}
			}
);

}
