/* Copyright IBM Corp. 2009, 2010  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.io.iframe");

dojo.declare("com.ibm.mm.builder.importWidget",[dijit._Widget, dijit._Templated],{	
	//todo refactory the style
	widgetsInTemplate: true,    
	templateString: 
		'<div>'+
			'<form style="margin:0" enctype="multipart/form-data" dojoAttachPoint="importForm" id="" name="" accept-charset="UTF-8" method="post" onsubmit="javascript:return false;">' +
			'<div class="importWidget_selection_div">'+
				'<div>'+
					'<span dojoAttachPoint="message"></span>'+
				'</div>'+
				'<div>'+
					'<label id="importWidget_label" dojoAttachPoint="widgetTitleLabel" class="importWidget_item_title"></label>'+
				'</div>'+
				'<div class="importWidget_item_content">'+
					'<nobr>'+
						'<input size="32" id="filename_value" disabled="true" wairole="textbox" aria-label="File:" type="text" name="filename_value" value="" />'+
						'<button wairole="button" aria-label="Browse" dojoAttachEvent="onkeydown:_handleBrowseButtonClick"><a href="javascript: void(0)">Browse...</a></button>'+
						'<input style="position:relative; left:-260px; opacity:0; filter:alpha(opacity: 0)" dojoAttachPoint="widgetName" name="browse" id="file" type="file" class="importWidget_input" size="32" dojoAttachEvent="onchange:_hideMessage" />'+
					'</nobr>'+
				'</div>'+
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" '+
				'IWID="_IWID_" '+
				'saveText="${I_COMMON_OK}" '+
				'cancelClass="common_cancel importWidget_cancel" '+
				'dojoAttachEvent="onSave:save, onCancel:hide">'+
			'</div>'+			
			/*			
			'<div class="importWidget_btn_line">'+
				'<a class="importWidget_cancel" dojoAttachPoint="cancelBtn" dojoAttachEvent="onclick: hide"></a>'+
				'<input type="button" class="lotusFormButton" dojoAttachPoint="okBtn" dojoAttachEvent="onclick: save"/>'+
			'</div>'+
			*/
			'</form>' +
		'</div>',
	
	I_COMMON_OK: "${I_COMMON_OK}",
		
    onLoad: function() {
		this.es = com.ibm.mashups.services.ServiceManager.getService("eventService");
		var contentDiv = dojo.query("."+com.ibm.mm.builder.constant.iWidgetContent, this.iContext.getRootElement())[0];
		if (contentDiv) {
			contentDiv.appendChild(this.domNode);
		}
		else {
			this.iContext.getRootElement().appendChild(this.domNode);
		}
	},

	postCreate: function(){
		this.widgetTitleLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_IMPORT_WIDGET_PROMPT;
		//this.cancelBtn.innerHTML=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL;
		//this.okBtn.value=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK;
	},
	
	/**
	 * hide the page property dialog
	 */		
	hide: function(){
		this.es.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
		this.widgetName.value = "";
	},
	
	/**
	 * reset the theme selection
	 */
	updateProperty: function(payload){
		this._hideMessage();
		this.spaceId = null;
		var formElement = this.importForm;
		var fileInput = this.widgetName;
		if(payload && payload.spaceId) {
			this.spaceId = payload.spaceId;
			formElement.id = "pageForm";
			formElement.name = "pageForm";
			fileInput.name = "xmlPage";
		}
		else {
			formElement.id = "spaceForm";
			formElement.name = "spaceForm";
			fileInput.name = "zip";
		}
	},
		
	save: function(){
		var fileInput = this.widgetName;
		if (fileInput.value === null || fileInput.value === "") {
			this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_FILENAME_IS_REQUIRED_0, "error");
			dojo.attr(this.widgetName, "aria-invalid", "true");
		}
		else 
		{
	       	var spaceModel = com.ibm.mashups.enabler.model.Factory.getSpaceModel();
			var submittableForm;
			var parameters = {};
			if (this.spaceId) {
				// post the spaceId which the page will be added to server.
				if (fileInput.value.match(/.xml$/) || fileInput.value.match(/.data$/) || fileInput.value.match(/.zip$/)) {
					if (fileInput.value.match(/.xml$/) || fileInput.value.match(/.zip$/)){
						submittableForm = spaceModel.getSubmittableForm("pageForm", this.spaceId);
						parameters.type = "page";
					}
					else{
						// when we import page .data file came from BSpace old data, we should use the paceForm and post the spaceId to space rest api.
						submittableForm = spaceModel.getSubmittableForm("spacePageForm", this.spaceId, "pageForm");
						parameters.type = "spacePage";
					}					
				}
				else {
					this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_INVALID_FILE_TYPE_0, "error");
					dojo.attr(this.widgetName, "aria-invalid", "true");
				}
			}
			else {
				if (fileInput.value.match(/.zip$/) || fileInput.value.match(/.data$/)) {
					submittableForm = spaceModel.getSubmittableForm("spaceForm");
				}
				else {
					this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_INVALID_FILE_TYPE_0, "error");
					dojo.attr(this.widgetName, "aria-invalid", "true");
				}
			}
			var _self = this;
			var callbackhandler = function(data, status, parameters) {
				var importType = parameters.type;
				if (status == "201") {
					parameters.dialog.hide();	
					
					var embeddedData = data;
					var hasCDATA = embeddedData.substring(1,9) == "![CDATA[";
					if (hasCDATA) 
						embeddedData = data.substring(9,data.length-3);
												
					//parse data
					var encodedEmbeddedData = embeddedData.replace(/&/g,"&amp;");
					var responseXML = dojox.data.dom.createDocument(encodedEmbeddedData);
					var id;
					var entryNodes = responseXML.getElementsByTagName("atom:entry");
					if (entryNodes.length === 0) {
						entryNodes = responseXML.getElementsByTagName("entry");
					}
					
					// if upload the old BSpace .data file, the response feeds is different with normal. Like <atom:feed><atom:id/></atom:feed>
					// so the responseXML.getElementsByTagName("entry") would return empty list. 
					if (entryNodes.length === 0) {
						entryNodes = responseXML.getElementsByTagName("atom:feed");
                        if (entryNodes.length === 0) {
                            entryNodes = responseXML.getElementsByTagName("feed");
                        }
					}
					
					for (var i = 0; i < entryNodes.length; i++) {
						var childNodes = entryNodes[i].childNodes;
						for (var j=0;j<childNodes.length;j++) {
							var childNode = childNodes[j];
							if (childNode.nodeName == "atom:id") {
								id = childNode.firstChild.data;
								break;
							}
						}
					}
					var payload = id.split(":")[2];
					var _constants=null;
					// Refresh space manager
					if (importType === "page" || importType === "spacePage") {
						var newPageId = payload;
						var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
						var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);

                        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
                        navModel.invalidate(parentPageId);

						 _constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
						dojo.publish(_constants.Topic.Space.refresh, [_constants.Action.ADD_PAGE, {spaceId: _self.spaceId, parentPageId: parentPageId, page: newPage}]);
						
						// Handle the response about the importing old page data from BSpace.
						if(importType === "spacePage"){
							dojo.publish(_constants.Topic.Space.refresh,[_constants.Action.EDIT_SPACE, {spaceId: payload}]);
						}
						com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");						
					}
					else {						
						var es = com.ibm.mashups.services.ServiceManager.getService("eventService");						
						es.broadcastEvent("com.ibm.mashups.builder.spacemanager.spaceCreated", payload);
					}
				}
				else {
					if (importType === "page") {
						parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PAGE_IMPORT_FAIL_1, [data.message]), "error");
					}
					else {
						parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_FAIL_1, [data.message]), "error");
					}
				}
                if (this.widgetName) this.widgetName.value = "";
			};
			if (submittableForm) {
				this._hideMessage();
				var deferred = submittableForm.submit();
				parameters.dialog = this;				
				deferred.setFinishedCallback(callbackhandler, parameters);
				deferred.start();
			}
		}
	},

	_showMessage : function(message, type) {
		if(!this._messageControl){
			var node = dojo.doc.createElement("div");
			this.message.appendChild(node);
			this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
			messageType: 'error'}, node);
		}
		this._messageControl.attr({
			"message" : message,
			"type" : type || "info"
		});
		this._messageControl.show();
	},

	_handleBrowseButtonClick: function(e) {
		if (e.keyCode === dojo.keys.ENTER) {
			if (dojo.isIE) {
				this.widgetName.click();
			}
			this.widgetName.focus();	
		}
	},
	
	_hideMessage : function() {
		// Fix the input for bidi
		var value = this.widgetName.value;
		if(value !== null || value !== '') {
			// get the filename out of the full path
			// which may be shown depending on user and/or browser security settings
			value = value.split("\\").pop(); 
			dojo.attr(dojo.byId("filename_value"), "value", value);
		}

		if(this._messageControl){
			this._messageControl.hide();
		}
	},
		
	onImportWidget: function(iEvent) {
		this.updateProperty(iEvent.payload);
	}

});
