/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget.ColorPalette");

dojo.require('dijit.ColorPalette');
dojo.require("dojo.string");

dojo.declare("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget.ColorPalette", dijit.ColorPalette, {
    
    // timeoutChangeRate: Number
	//		Fraction of time used to change the typematic timer between events
	//		1.0 means that each typematic event fires at defaultTimeout intervals
	//		< 1.0 means that each typematic event fires at an increasing faster rate
    timeoutChangeRate: 0.80,
	// palette: String
	//		Size of grid, either "7x10" or "3x4".
	palette: "8x16",

	// _palettes: Map
	// 		This represents the value of the colors.
	//		The first level is a hashmap of the different arrays available
	//		The next two dimensions represent the columns and rows of colors.
	_palettes: {
		"8x16": [
			["#FFFFFF", "#DDDDDD", "#BBBBBB", "#999999", "#666666", "#444444", "#222222", "#000000"],
			["#FFEEEE", "#FFFFDD", "#FFFFEE", "#EEFFEE", "#EEFFFF", "#EEEEFF", "#FFEEFF", "#FFEEFF"],
			["#FFCCCC", "#FFFFBB", "#FFFFCC", "#CCFFCC", "#CCFFFF", "#CCCCFF", "#FFCCFF", "#FFCCFF"],
			["#FFAAAA", "#FFEE99", "#FFFFAA", "#AAFFAA", "#AAFFFF", "#AAAAFF", "#EEAAFF", "#FFAAFF"],
			["#FF8888", "#FFDD88", "#FFFF88", "#88FF88", "#88FFFF", "#8888FF", "#DD88FF", "#FF88FF"],
			["#FF6666", "#FFCC66", "#FFFF66", "#66FF66", "#66FFFF", "#6666FF", "#CC66FF", "#FF66FF"],
			["#FF4444", "#FFBB44", "#FFFF44", "#44FF44", "#44FFFF", "#4444FF", "#BB44FF", "#FF44FF"],
			["#FF2222", "#FFAA22", "#FFFF22", "#22FF22", "#22FFFF", "#2222FF", "#AA22FF", "#FF22FF"],
			["#FF0000", "#FF9900", "#FFFF00", "#00FF00", "#00FFFF", "#0000FF", "#9900FF", "#FF00FF"],
			["#DD0000", "#DD8800", "#DDDD00", "#00DD00", "#00DDDD", "#0000DD", "#8800DD", "#DD00DD"],
			["#BB0000", "#BB7700", "#BBBB00", "#00BB00", "#00BBBB", "#0000BB", "#7700BB", "#BB00BB"],
			["#990000", "#996600", "#999900", "#009900", "#009999", "#000099", "#660099", "#990099"],
			["#770000", "#774400", "#777700", "#007700", "#007777", "#000077", "#550077", "#770077"],
			["#550000", "#553300", "#555500", "#005500", "#005555", "#000055", "#440055", "#550055"],
			["#330000", "#332200", "#333300", "#003300", "#003333", "#000033", "#330033", "#330033"],
			["#110000", "#111100", "#111100", "#001100", "#001111", "#000011", "#220011", "#110011"]
		]
	},

	_name: {
		"8x16": [
			["White", "Fog", "Silver", "Dark Gray", "Dim Gray", "Charcoal", "Soot", "Black"],
			["Lavender Blush", "Light Yellow", "Ivory", "Pale Jade", "Azure", "Mist", "Pale Lavender", "Pale Lavender"],
			["Pink", "Cornsilk", "Lemon Chiffon", "Mint", "Overcast Blue", "Slate Blue", "Light Violet", "Light Violet"],
			["Light Pink", "Moccasin", "Cream", "Pale Green", "Pale Turquoise", "Light Cornflower", "Violet", "Bubblegum"],
			["Light Coral", "Apricot", "Butter", "Light Green", "Light Sky Blue", "Sky Blue", "Plum", "Cherry Blossom"],
			["Salmon", "Peach", "Banana", "Spearmint", "Swimming Pool Blue", "Blue Flower", "Lilac", "Light Magenta"],
			["Tomato", "Orange", "Yellow Corn", "Florescent Green", "Blue Taffy", "Royal Blue", "Wisteria", "Pink Lemonade"],
			["Scarlet", "Dark Orange", "Canary", "Lawn Green", "Electric Blue", "Lapis Lazuli", "Heliotrope", "Cezanne Rose"],
			["Red", "Tangerine", "Yellow", "Lime", "Cyan", "Blue", "Plasma", "Magenta"],
			["Venetian Red", "Cappuccino", "Pistachio", "Emerald", "Turquoise", "Medium Blue", "Amethyst", "Mulberry"],
			["Fire Brick", "Dark Goldenrod", "Khaki Green", "Grass green", "Dark Turquoise", "Sapphire", "Iris", "Dark Fuchsia"],
			["Dark Red", "Sienna", "Scuppernong", "Apple", "Dark Cyan", "Dark Blue", "Delphinium", "Hyacinth"],
			["Maroon", "Saddle Brown", "Olive", "Green", "Teal", "Navy", "Grape", "Purple"],
			["Burgundy", "Raw Umber", "Hazel", "Dark Green", "Deep Sea Green", "Midnight Blue", "Morning Glory", "Cranberry-Grape Juice"],
			["Mahogany", "Bistre", "Avocado Peel", "Forest Green", "Dark Teal", "Ultramarine", "Acai", "Acai"],
			["Ruby Black", "Dark Brown", "Onyx", "Black Forest", "Deep Sea", "Blackberry", "Blackberry Cobbler", "Blackcurrant"]
		]
	},
	// _imagePaths: Map
	//		Path to the palette images
	_imagePaths: {
		// #11662: Lazyload image path to support custom context root
		"8x16": function(){
			return dojo.moduleUrl("com.ibm.mm.widget.dataViewer._WB_VER_.v210", "widget/templates/images/color_palette.png")
		}
	},

	// _paletteDims: Object
	//		Size of the supported palettes for alignment purposes.
	_paletteDims: {
		"8x16": {"width": "166px", "height": "326px"}
	},
    
    _paletteCoords: {
		"leftOffset": 3, "topOffset": 3,
		"cWidth": 20, "cHeight": 20
	},
    
    /**
     * @Override
     */
	buildRendering: function(){
    
    	// Instantiate the template, which makes a skeleton into which we'll insert a bunch of
		// <img> nodes
		dijit._Widget.prototype.buildRendering.apply(this,arguments);
        dijit._Templated.prototype.buildRendering.apply(this,arguments);
        
		// A name has to be given to the colorMap, this needs to be unique per Palette.
		dojo.mixin(this.divNode.style, this._paletteDims[this.palette]);
        
        this.imageNode.setAttribute("src", this._imagePaths[this.palette]().toString());
        
		var choices = this._palettes[this.palette];
		this.domNode.style.position = "relative";
		this._cellNodes = [];
        // CUSTOMIZATION START
        //this.colorNames = dojo.i18n.getLocalization("dojo", "colors", this.lang);
        // CUSTOMIZATION END
		var url = this._blankGif,
			colorObject = new dojo.Color(),
			coords = this._paletteCoords;
		for(var row=0; row < choices.length; row++){
			var rowNode = dojo.create("div", {
				role: "row"
			}, this.divNode);
			for(var col=0; col < choices[row].length; col++){

				var color = choices[row][col],
						colorValue = colorObject.setColor(color);

                var red = parseInt("0x" + color.substr(1, 2), 16),
                    green = parseInt("0x" + color.substr(3, 2), 16),
                    blue = parseInt("0x" + color.substr(5, 2), 16);
                
				var cellNode = dojo.create("span", {
					"class": "dijitPaletteCell",
					tabIndex: "-1",
					title: dojo.string.substitute(com.ibm.mm.widget.dataViewer._WB_VER_.v210.dataViewerMessages.L_COLOR_PICKER_COLOR_TITLE, [red, green, blue]),   // Customization: this.colorNames[color],
					style: {
						top: coords.topOffset + (row * coords.cHeight) + "px",
						left: coords.leftOffset + (col * coords.cWidth) + "px"
					}
				});

				var imgNode = dojo.create("img",{
					src: url,
					"class":"dijitPaletteImg",
					alt: dojo.string.substitute(com.ibm.mm.widget.dataViewer._WB_VER_.v210.dataViewerMessages.L_COLOR_PICKER_COLOR_TITLE, [red, green, blue])     // Customization: this.colorNames[color]
				}, cellNode);

				// FIXME: color is an attribute of img?
				imgNode.color = colorValue.toHex();
				var imgStyle = imgNode.style;
				imgStyle.color = imgStyle.backgroundColor = imgNode.color;

				dojo.forEach(["Dijitclick", "MouseEnter", "MouseLeave", "Focus"], function(handler){
					this.connect(cellNode, "on" + handler.toLowerCase(), "_onCell" + handler);
				}, this);

				dojo.place(cellNode, rowNode);

				dijit.setWaiRole(cellNode, "gridcell");
				cellNode.index = this._cellNodes.length;
				this._cellNodes.push(cellNode);
			}
		}
		this._xDim = choices[0].length;
		this._yDim = choices.length;

		// Now set all events
		// The palette itself is navigated to with the tab key on the keyboard
		// Keyboard navigation within the Palette is with the arrow keys
		// Spacebar selects the color.
		// For the up key the index is changed by negative the x dimension.

		var keyIncrementMap = {
			UP_ARROW: -this._xDim,
			// The down key the index is increase by the x dimension.
			DOWN_ARROW: this._xDim,
			// Right and left move the index by 1.
			RIGHT_ARROW: 1,
			LEFT_ARROW: -1
		};
		for(var key in keyIncrementMap){
			this._connects.push(dijit.typematic.addKeyListener(this.domNode,
				{charOrCode:dojo.keys[key], ctrlKey:false, altKey:false, shiftKey:false},
				this,
				function(){
					var increment = keyIncrementMap[key];
					return function(count){ this._navigateByKey(increment, count); };
				}(),
				this.timeoutChangeRate, this.defaultTimeout));
		}
	}
});
